#include <Arduino.h>
#include "MarkovWord.h"

#define PAIR(_first, _second, _len)     (word)((_first - 'a') | ((_second - 'a') << 5) | (((_len) & 0x1F) << 10))
#define TRIPLE(_first, _second, _third) (word)((_first - 'a') | ((_second - 'a') << 5) | (((_third - 'a') & 0x1F) << 10) | 0x8000)
#define _CHR(_char, _count)             (word)((_char - 'a') | ((_count) << 5))
#define END 0x0000

// 4876 bytes
PROGMEM prog_uint16_t CMarkovWord::kMarkovTable[] = 
{
  PAIR('a', 'a', 2),
  _CHR('{', 1024+(-1)),
  _CHR('m', 1024),
  PAIR('b', 'a', 19),
  _CHR('l', 364+(-2)),
  _CHR('c', 339),
  _CHR('t', 289),
  _CHR('r', 289),
  _CHR('n', 213),
  _CHR('s', 151),
  _CHR('b', 113),
  _CHR('g', 75),
  _CHR('p', 38),
  _CHR('k', 25),
  _CHR('u', 25),
  _CHR('h', 25),
  _CHR('i', 25),
  _CHR('{', 13),
  _CHR('z', 13),
  _CHR('f', 13),
  _CHR('d', 13),
  _CHR('m', 13),
  _CHR('y', 13),
  PAIR('c', 'a', 17),
  _CHR('l', 639+(1)),
  _CHR('t', 387),
  _CHR('r', 289),
  _CHR('n', 166),
  _CHR('p', 129),
  _CHR('s', 98),
  _CHR('b', 86),
  _CHR('u', 55),
  _CHR('{', 43),
  _CHR('d', 43),
  _CHR('m', 37),
  _CHR('v', 25),
  _CHR('c', 25),
  _CHR('f', 6),
  _CHR('g', 6),
  _CHR('q', 6),
  _CHR('y', 6),
  PAIR('d', 'a', 17),
  _CHR('t', 397+(-2)),
  _CHR('n', 251),
  _CHR('r', 230),
  _CHR('l', 167),
  _CHR('b', 167),
  _CHR('m', 146),
  _CHR('i', 125),
  _CHR('u', 104),
  _CHR('p', 84),
  _CHR('{', 63),
  _CHR('y', 63),
  _CHR('g', 63),
  _CHR('s', 63),
  _CHR('c', 42),
  _CHR('d', 42),
  _CHR('v', 21),
  _CHR('z', 21),
  PAIR('e', 'a', 19),
  _CHR('r', 386+(-1)),
  _CHR('d', 289),
  _CHR('t', 207),
  _CHR('l', 193),
  _CHR('s', 186),
  _CHR('c', 152),
  _CHR('n', 124),
  _CHR('m', 110),
  _CHR('k', 110),
  _CHR('b', 83),
  _CHR('p', 48),
  _CHR('v', 34),
  _CHR('{', 28),
  _CHR('f', 28),
  _CHR('g', 28),
  _CHR('w', 14),
  _CHR('z', 14),
  _CHR('u', 7),
  _CHR('h', 7),
  PAIR('f', 'a', 15),
  _CHR('c', 395),
  _CHR('n', 279),
  _CHR('t', 233),
  _CHR('r', 209),
  _CHR('i', 186),
  _CHR('s', 163),
  _CHR('l', 116),
  _CHR('v', 116),
  _CHR('m', 93),
  _CHR('b', 70),
  _CHR('g', 47),
  _CHR('e', 47),
  _CHR('d', 47),
  _CHR('k', 23),
  _CHR('w', 23),
  PAIR('g', 'a', 16),
  _CHR('t', 606+(-2)),
  _CHR('l', 292),
  _CHR('r', 272),
  _CHR('n', 209),
  _CHR('s', 167),
  _CHR('m', 125),
  _CHR('g', 63),
  _CHR('i', 63),
  _CHR('b', 63),
  _CHR('{', 42),
  _CHR('u', 42),
  _CHR('z', 21),
  _CHR('w', 21),
  _CHR('y', 21),
  _CHR('f', 21),
  _CHR('p', 21),
  PAIR('h', 'a', 21),
  _CHR('n', 514),
  _CHR('r', 298),
  _CHR('l', 134),
  _CHR('m', 134),
  _CHR('b', 113),
  _CHR('g', 103),
  _CHR('i', 93),
  _CHR('s', 93),
  _CHR('v', 72),
  _CHR('t', 72),
  _CHR('k', 62),
  _CHR('c', 51),
  _CHR('d', 51),
  _CHR('p', 51),
  _CHR('u', 41),
  _CHR('{', 31),
  _CHR('f', 31),
  _CHR('z', 31),
  _CHR('w', 31),
  _CHR('e', 31),
  _CHR('y', 10),
  PAIR('i', 'a', 12),
  _CHR('l', 695+(-1)),
  _CHR('{', 348),
  _CHR('n', 338),
  _CHR('t', 309),
  _CHR('r', 106),
  _CHR('b', 97),
  _CHR('c', 58),
  _CHR('g', 29),
  _CHR('s', 29),
  _CHR('m', 19),
  _CHR('p', 10),
  _CHR('e', 10),
  PAIR('j', 'a', 10),
  _CHR('c', 409+(-1)),
  _CHR('m', 409),
  _CHR('z', 328),
  _CHR('r', 246),
  _CHR('h', 164),
  _CHR('i', 164),
  _CHR('{', 82),
  _CHR('b', 82),
  _CHR('n', 82),
  _CHR('u', 82),
  PAIR('k', 'a', 13),
  _CHR('b', 434+(1)),
  _CHR('g', 248),
  _CHR('t', 248),
  _CHR('{', 248),
  _CHR('r', 186),
  _CHR('f', 186),
  _CHR('p', 124),
  _CHR('d', 62),
  _CHR('w', 62),
  _CHR('h', 62),
  _CHR('e', 62),
  _CHR('l', 62),
  _CHR('x', 62),
  PAIR('l', 'a', 21),
  _CHR('t', 425+(4)),
  _CHR('n', 271),
  _CHR('r', 259),
  _CHR('s', 154),
  _CHR('c', 154),
  _CHR('y', 142),
  _CHR('m', 92),
  _CHR('{', 86),
  _CHR('i', 86),
  _CHR('v', 55),
  _CHR('d', 49),
  _CHR('w', 49),
  _CHR('p', 49),
  _CHR('u', 37),
  _CHR('b', 37),
  _CHR('z', 31),
  _CHR('g', 25),
  _CHR('l', 18),
  _CHR('h', 12),
  _CHR('k', 6),
  _CHR('a', 6),
  PAIR('m', 'a', 20),
  _CHR('n', 587),
  _CHR('t', 357),
  _CHR('r', 204),
  _CHR('l', 153),
  _CHR('g', 134),
  _CHR('k', 121),
  _CHR('c', 96),
  _CHR('s', 96),
  _CHR('{', 89),
  _CHR('i', 57),
  _CHR('m', 32),
  _CHR('b', 32),
  _CHR('d', 26),
  _CHR('x', 13),
  _CHR('p', 13),
  _CHR('y', 13),
  _CHR('v', 6),
  _CHR('z', 6),
  _CHR('j', 6),
  _CHR('a', 6),
  PAIR('n', 'a', 20),
  _CHR('l', 652+(6)),
  _CHR('t', 367),
  _CHR('r', 202),
  _CHR('b', 127),
  _CHR('n', 105),
  _CHR('m', 90),
  _CHR('{', 67),
  _CHR('i', 67),
  _CHR('g', 60),
  _CHR('c', 60),
  _CHR('u', 52),
  _CHR('p', 52),
  _CHR('s', 37),
  _CHR('d', 30),
  _CHR('w', 22),
  _CHR('v', 15),
  _CHR('f', 15),
  _CHR('y', 7),
  _CHR('h', 7),
  _CHR('k', 7),
  PAIR('o', 'a', 14),
  _CHR('d', 496+(1)),
  _CHR('t', 434),
  _CHR('r', 310),
  _CHR('c', 155),
  _CHR('n', 155),
  _CHR('s', 93),
  _CHR('p', 93),
  _CHR('x', 62),
  _CHR('k', 62),
  _CHR('l', 62),
  _CHR('v', 31),
  _CHR('f', 31),
  _CHR('m', 31),
  _CHR('{', 31),
  PAIR('p', 'a', 20),
  _CHR('r', 549+(-1)),
  _CHR('t', 381),
  _CHR('c', 204),
  _CHR('n', 177),
  _CHR('s', 160),
  _CHR('l', 124),
  _CHR('i', 124),
  _CHR('p', 62),
  _CHR('g', 53),
  _CHR('e', 35),
  _CHR('w', 35),
  _CHR('d', 27),
  _CHR('b', 27),
  _CHR('{', 18),
  _CHR('u', 18),
  _CHR('y', 18),
  _CHR('q', 9),
  _CHR('v', 9),
  _CHR('m', 9),
  _CHR('k', 9),
  PAIR('r', 'a', 23),
  _CHR('t', 385),
  _CHR('n', 260),
  _CHR('c', 204),
  _CHR('p', 200),
  _CHR('l', 188),
  _CHR('s', 109),
  _CHR('i', 94),
  _CHR('b', 83),
  _CHR('m', 79),
  _CHR('d', 79),
  _CHR('{', 64),
  _CHR('v', 57),
  _CHR('g', 49),
  _CHR('y', 41),
  _CHR('r', 30),
  _CHR('u', 26),
  _CHR('f', 26),
  _CHR('w', 23),
  _CHR('z', 19),
  _CHR('k', 11),
  _CHR('o', 8),
  _CHR('j', 8),
  _CHR('x', 4),
  PAIR('s', 'a', 19),
  _CHR('n', 348+(-3)),
  _CHR('l', 218),
  _CHR('t', 218),
  _CHR('u', 189),
  _CHR('d', 131),
  _CHR('c', 116),
  _CHR('b', 116),
  _CHR('r', 102),
  _CHR('p', 87),
  _CHR('g', 87),
  _CHR('y', 87),
  _CHR('m', 73),
  _CHR('f', 73),
  _CHR('v', 58),
  _CHR('i', 44),
  _CHR('{', 44),
  _CHR('s', 29),
  _CHR('w', 15),
  _CHR('h', 15),
  PAIR('t', 'a', 20),
  _CHR('t', 367),
  _CHR('l', 331),
  _CHR('n', 248),
  _CHR('b', 231),
  _CHR('r', 183),
  _CHR('i', 130),
  _CHR('s', 89),
  _CHR('c', 83),
  _CHR('g', 65),
  _CHR('m', 59),
  _CHR('{', 59),
  _CHR('k', 53),
  _CHR('p', 35),
  _CHR('x', 30),
  _CHR('d', 18),
  _CHR('u', 18),
  _CHR('f', 18),
  _CHR('v', 12),
  _CHR('w', 12),
  _CHR('y', 6),
  PAIR('u', 'a', 13),
  _CHR('l', 710),
  _CHR('t', 328),
  _CHR('n', 273),
  _CHR('r', 273),
  _CHR('d', 136),
  _CHR('b', 82),
  _CHR('i', 55),
  _CHR('s', 55),
  _CHR('{', 27),
  _CHR('k', 27),
  _CHR('c', 27),
  _CHR('y', 27),
  _CHR('m', 27),
  PAIR('v', 'a', 13),
  _CHR('l', 524+(-1)),
  _CHR('t', 399),
  _CHR('n', 300),
  _CHR('s', 175),
  _CHR('r', 125),
  _CHR('{', 100),
  _CHR('b', 100),
  _CHR('i', 100),
  _CHR('p', 50),
  _CHR('m', 50),
  _CHR('g', 50),
  _CHR('c', 50),
  _CHR('u', 25),
  PAIR('w', 'a', 14),
  _CHR('r', 705+(-1)),
  _CHR('y', 268),
  _CHR('t', 218),
  _CHR('l', 185),
  _CHR('s', 151),
  _CHR('i', 134),
  _CHR('v', 101),
  _CHR('b', 84),
  _CHR('n', 67),
  _CHR('d', 50),
  _CHR('g', 34),
  _CHR('p', 17),
  _CHR('f', 17),
  _CHR('c', 17),
  PAIR('x', 'a', 3),
  _CHR('t', 1024+(-1)),
  _CHR('m', 512),
  _CHR('s', 512),
  PAIR('y', 'a', 11),
  _CHR('r', 379+(-1)),
  _CHR('b', 303),
  _CHR('n', 303),
  _CHR('l', 303),
  _CHR('p', 152),
  _CHR('g', 152),
  _CHR('w', 152),
  _CHR('c', 76),
  _CHR('m', 76),
  _CHR('d', 76),
  _CHR('s', 76),
  PAIR('z', 'a', 5),
  _CHR('t', 1445+(1)),
  _CHR('r', 301),
  _CHR('n', 120),
  _CHR('{', 120),
  _CHR('b', 60),
  PAIR('{', 'a', 20),
  _CHR('n', 331+(-1)),
  _CHR('d', 203),
  _CHR('s', 197),
  _CHR('r', 187),
  _CHR('c', 160),
  _CHR('p', 139),
  _CHR('b', 133),
  _CHR('l', 117),
  _CHR('m', 112),
  _CHR('u', 96),
  _CHR('t', 75),
  _CHR('f', 69),
  _CHR('g', 59),
  _CHR('i', 53),
  _CHR('e', 48),
  _CHR('w', 27),
  _CHR('v', 21),
  _CHR('x', 11),
  _CHR('z', 5),
  _CHR('q', 5),
  PAIR('a', 'b', 12),
  _CHR('l', 1089+(-1)),
  _CHR('i', 307),
  _CHR('s', 121),
  _CHR('b', 121),
  _CHR('o', 93),
  _CHR('r', 65),
  _CHR('e', 56),
  _CHR('{', 56),
  _CHR('a', 47),
  _CHR('u', 37),
  _CHR('n', 28),
  _CHR('y', 28),
  PAIR('b', 'b', 7),
  _CHR('l', 885),
  _CHR('i', 387),
  _CHR('e', 277),
  _CHR('y', 221),
  _CHR('{', 111),
  _CHR('a', 111),
  _CHR('u', 55),
  PAIR('d', 'b', 4),
  _CHR('l', 682+(1)),
  _CHR('a', 682),
  _CHR('o', 341),
  _CHR('e', 341),
  PAIR('e', 'b', 13),
  _CHR('o', 417+(-1)),
  _CHR('a', 341),
  _CHR('r', 303),
  _CHR('i', 227),
  _CHR('e', 190),
  _CHR('u', 152),
  _CHR('b', 152),
  _CHR('{', 76),
  _CHR('y', 38),
  _CHR('s', 38),
  _CHR('p', 38),
  _CHR('t', 38),
  _CHR('m', 38),
  PAIR('g', 'b', 3),
  _CHR('o', 1024+(-1)),
  _CHR('a', 512),
  _CHR('y', 512),
  PAIR('h', 'b', 3),
  _CHR('o', 1535),
  _CHR('l', 256),
  _CHR('a', 256),
  PAIR('i', 'b', 8),
  _CHR('l', 528+(1)),
  _CHR('i', 330),
  _CHR('e', 297),
  _CHR('u', 297),
  _CHR('r', 231),
  _CHR('b', 165),
  _CHR('{', 99),
  _CHR('a', 99),
  PAIR('k', 'b', 3),
  _CHR('o', 1024),
  _CHR('i', 682),
  _CHR('a', 341),
  PAIR('l', 'b', 6),
  _CHR('o', 640+(-1)),
  _CHR('i', 640),
  _CHR('{', 256),
  _CHR('a', 256),
  _CHR('e', 128),
  _CHR('u', 128),
  PAIR('m', 'b', 9),
  _CHR('l', 470),
  _CHR('a', 360),
  _CHR('e', 332),
  _CHR('o', 277),
  _CHR('r', 194),
  _CHR('{', 166),
  _CHR('i', 138),
  _CHR('m', 55),
  _CHR('u', 55),
  PAIR('n', 'b', 7),
  _CHR('a', 372+(1)),
  _CHR('r', 372),
  _CHR('u', 372),
  _CHR('e', 372),
  _CHR('l', 186),
  _CHR('i', 186),
  _CHR('o', 186),
  PAIR('o', 'b', 14),
  _CHR('a', 355+(-1)),
  _CHR('e', 273),
  _CHR('i', 273),
  _CHR('b', 246),
  _CHR('o', 218),
  _CHR('{', 164),
  _CHR('j', 136),
  _CHR('l', 109),
  _CHR('t', 55),
  _CHR('s', 55),
  _CHR('v', 55),
  _CHR('r', 55),
  _CHR('n', 27),
  _CHR('w', 27),
  TRIPLE('p', 'b', 'r'),
  PAIR('r', 'b', 7),
  _CHR('i', 558),
  _CHR('o', 465),
  _CHR('a', 372),
  _CHR('e', 326),
  _CHR('l', 186),
  _CHR('{', 93),
  _CHR('u', 47),
  PAIR('s', 'b', 3),
  _CHR('a', 1170),
  _CHR('u', 585),
  _CHR('y', 292),
  PAIR('t', 'b', 5),
  _CHR('a', 744+(1)),
  _CHR('r', 558),
  _CHR('i', 372),
  _CHR('u', 186),
  _CHR('o', 186),
  PAIR('u', 'b', 14),
  _CHR('s', 467+(-3)),
  _CHR('e', 215),
  _CHR('j', 180),
  _CHR('b', 180),
  _CHR('{', 180),
  _CHR('l', 180),
  _CHR('i', 180),
  _CHR('t', 108),
  _CHR('r', 108),
  _CHR('a', 72),
  _CHR('m', 72),
  _CHR('o', 36),
  _CHR('g', 36),
  _CHR('c', 36),
  PAIR('w', 'b', 2),
  _CHR('o', 1365),
  _CHR('a', 682),
  PAIR('y', 'b', 4),
  _CHR('a', 910+(1)),
  _CHR('o', 682),
  _CHR('e', 227),
  _CHR('b', 227),
  PAIR('{', 'b', 8),
  _CHR('a', 453),
  _CHR('e', 336),
  _CHR('o', 320),
  _CHR('r', 261),
  _CHR('i', 240),
  _CHR('u', 219),
  _CHR('l', 213),
  _CHR('y', 5),
  PAIR('a', 'c', 14),
  _CHR('k', 439+(1)),
  _CHR('t', 395),
  _CHR('e', 290),
  _CHR('h', 231),
  _CHR('c', 156),
  _CHR('i', 141),
  _CHR('r', 82),
  _CHR('{', 67),
  _CHR('y', 67),
  _CHR('o', 52),
  _CHR('u', 52),
  _CHR('a', 30),
  _CHR('l', 22),
  _CHR('q', 22),
  TRIPLE('b', 'c', 'l'),
  PAIR('c', 'c', 8),
  _CHR('u', 682),
  _CHR('e', 455),
  _CHR('o', 341),
  _CHR('i', 227),
  _CHR('a', 114),
  _CHR('h', 114),
  _CHR('l', 57),
  _CHR('r', 57),
  PAIR('d', 'c', 2),
  _CHR('a', 1638),
  _CHR('l', 409),
  PAIR('e', 'c', 12),
  _CHR('t', 788+(-1)),
  _CHR('o', 291),
  _CHR('i', 214),
  _CHR('e', 180),
  _CHR('k', 146),
  _CHR('u', 103),
  _CHR('r', 94),
  _CHR('a', 86),
  _CHR('h', 77),
  _CHR('l', 51),
  _CHR('c', 9),
  _CHR('{', 9),
  TRIPLE('g', 'c', 'o'),
  PAIR('h', 'c', 3),
  _CHR('a', 682+(1)),
  _CHR('l', 682),
  _CHR('r', 682),
  PAIR('i', 'c', 13),
  _CHR('{', 703+(-1)),
  _CHR('a', 515),
  _CHR('i', 185),
  _CHR('k', 161),
  _CHR('e', 130),
  _CHR('s', 98),
  _CHR('o', 63),
  _CHR('t', 59),
  _CHR('u', 59),
  _CHR('r', 47),
  _CHR('h', 16),
  _CHR('y', 8),
  _CHR('c', 4),
  TRIPLE('k', 'c', 'o'),
  PAIR('l', 'c', 6),
  _CHR('o', 512+(-1)),
  _CHR('a', 512),
  _CHR('h', 384),
  _CHR('u', 256),
  _CHR('e', 256),
  _CHR('l', 128),
  PAIR('m', 'c', 2),
  _CHR('i', 1365),
  _CHR('h', 682),
  PAIR('n', 'c', 10),
  _CHR('e', 848),
  _CHR('i', 261),
  _CHR('h', 237),
  _CHR('o', 228),
  _CHR('y', 139),
  _CHR('t', 98),
  _CHR('l', 73),
  _CHR('a', 65),
  _CHR('r', 65),
  _CHR('u', 33),
  PAIR('o', 'c', 12),
  _CHR('k', 441+(2)),
  _CHR('a', 346),
  _CHR('i', 283),
  _CHR('h', 220),
  _CHR('e', 189),
  _CHR('r', 126),
  _CHR('c', 126),
  _CHR('o', 110),
  _CHR('u', 94),
  _CHR('l', 47),
  _CHR('t', 47),
  _CHR('y', 16),
  TRIPLE('p', 'c', 'o'),
  PAIR('r', 'c', 9),
  _CHR('h', 773+(1)),
  _CHR('e', 318),
  _CHR('u', 250),
  _CHR('i', 250),
  _CHR('o', 205),
  _CHR('a', 114),
  _CHR('l', 68),
  _CHR('r', 45),
  _CHR('{', 23),
  PAIR('s', 'c', 9),
  _CHR('r', 512+(-1)),
  _CHR('o', 467),
  _CHR('e', 256),
  _CHR('a', 256),
  _CHR('i', 226),
  _CHR('h', 166),
  _CHR('u', 105),
  _CHR('l', 45),
  _CHR('y', 15),
  PAIR('t', 'c', 2),
  _CHR('h', 1985),
  _CHR('u', 62),
  PAIR('u', 'c', 11),
  _CHR('k', 452),
  _CHR('t', 425),
  _CHR('e', 239),
  _CHR('h', 213),
  _CHR('i', 213),
  _CHR('c', 133),
  _CHR('a', 106),
  _CHR('l', 106),
  _CHR('o', 106),
  _CHR('u', 27),
  _CHR('r', 27),
  PAIR('w', 'c', 2),
  _CHR('a', 1024+(-1)),
  _CHR('o', 1024),
  PAIR('x', 'c', 6),
  _CHR('l', 455),
  _CHR('e', 455),
  _CHR('u', 455),
  _CHR('i', 341),
  _CHR('a', 227),
  _CHR('r', 114),
  PAIR('y', 'c', 5),
  _CHR('h', 834),
  _CHR('o', 531),
  _CHR('a', 303),
  _CHR('l', 227),
  _CHR('e', 152),
  PAIR('{', 'c', 9),
  _CHR('o', 830),
  _CHR('a', 365),
  _CHR('h', 292),
  _CHR('r', 221),
  _CHR('l', 147),
  _CHR('u', 90),
  _CHR('e', 54),
  _CHR('i', 35),
  _CHR('y', 13),
  PAIR('a', 'd', 20),
  _CHR('e', 374),
  _CHR('i', 316),
  _CHR('{', 316),
  _CHR('v', 187),
  _CHR('o', 152),
  _CHR('d', 140),
  _CHR('a', 129),
  _CHR('r', 70),
  _CHR('y', 58),
  _CHR('u', 47),
  _CHR('s', 47),
  _CHR('w', 47),
  _CHR('l', 35),
  _CHR('m', 35),
  _CHR('j', 23),
  _CHR('t', 23),
  _CHR('n', 12),
  _CHR('g', 12),
  _CHR('q', 12),
  _CHR('b', 12),
  PAIR('d', 'd', 7),
  _CHR('l', 936+(1)),
  _CHR('e', 409),
  _CHR('i', 351),
  _CHR('r', 117),
  _CHR('a', 117),
  _CHR('m', 58),
  _CHR('y', 58),
  PAIR('e', 'd', 16),
  _CHR('{', 1639+(1)),
  _CHR('i', 151),
  _CHR('e', 58),
  _CHR('l', 39),
  _CHR('o', 35),
  _CHR('g', 29),
  _CHR('d', 19),
  _CHR('n', 19),
  _CHR('a', 16),
  _CHR('u', 13),
  _CHR('s', 10),
  _CHR('y', 6),
  _CHR('f', 3),
  _CHR('k', 3),
  _CHR('b', 3),
  _CHR('r', 3),
  PAIR('h', 'd', 2),
  _CHR('u', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('i', 'd', 13),
  _CHR('e', 861+(1)),
  _CHR('{', 404),
  _CHR('a', 183),
  _CHR('i', 156),
  _CHR('d', 104),
  _CHR('l', 91),
  _CHR('g', 78),
  _CHR('w', 39),
  _CHR('s', 39),
  _CHR('u', 39),
  _CHR('o', 26),
  _CHR('p', 13),
  _CHR('r', 13),
  PAIR('k', 'd', 2),
  _CHR('r', 1024+(-1)),
  _CHR('o', 1024),
  PAIR('l', 'd', 12),
  _CHR('{', 799+(-2)),
  _CHR('e', 300),
  _CHR('i', 250),
  _CHR('r', 150),
  _CHR('u', 100),
  _CHR('s', 100),
  _CHR('l', 100),
  _CHR('w', 50),
  _CHR('o', 50),
  _CHR('n', 50),
  _CHR('v', 50),
  _CHR('f', 50),
  PAIR('n', 'd', 19),
  _CHR('e', 600+(5)),
  _CHR('{', 375),
  _CHR('i', 292),
  _CHR('a', 142),
  _CHR('o', 135),
  _CHR('u', 105),
  _CHR('l', 97),
  _CHR('r', 82),
  _CHR('s', 45),
  _CHR('w', 30),
  _CHR('y', 22),
  _CHR('m', 22),
  _CHR('b', 22),
  _CHR('n', 22),
  _CHR('c', 15),
  _CHR('p', 15),
  _CHR('h', 7),
  _CHR('g', 7),
  _CHR('f', 7),
  PAIR('o', 'd', 15),
  _CHR('i', 421+(2)),
  _CHR('e', 341),
  _CHR('{', 281),
  _CHR('y', 181),
  _CHR('u', 161),
  _CHR('o', 140),
  _CHR('l', 120),
  _CHR('g', 100),
  _CHR('a', 80),
  _CHR('d', 60),
  _CHR('p', 60),
  _CHR('s', 40),
  _CHR('b', 20),
  _CHR('c', 20),
  _CHR('k', 20),
  TRIPLE('p', 'd', 'a'),
  PAIR('r', 'd', 14),
  _CHR('{', 940+(-1)),
  _CHR('e', 292),
  _CHR('i', 251),
  _CHR('l', 146),
  _CHR('a', 104),
  _CHR('o', 84),
  _CHR('r', 63),
  _CHR('c', 42),
  _CHR('p', 21),
  _CHR('h', 21),
  _CHR('s', 21),
  _CHR('n', 21),
  _CHR('m', 21),
  _CHR('u', 21),
  PAIR('s', 'd', 2),
  _CHR('a', 1365),
  _CHR('i', 682),
  TRIPLE('t', 'd', 'o'),
  PAIR('u', 'd', 10),
  _CHR('e', 546+(2)),
  _CHR('g', 318),
  _CHR('i', 318),
  _CHR('d', 273),
  _CHR('o', 182),
  _CHR('{', 182),
  _CHR('y', 91),
  _CHR('u', 45),
  _CHR('f', 45),
  _CHR('r', 45),
  PAIR('w', 'd', 4),
  _CHR('{', 877+(1)),
  _CHR('e', 585),
  _CHR('l', 292),
  _CHR('y', 292),
  PAIR('y', 'd', 2),
  _CHR('r', 1890),
  _CHR('e', 157),
  PAIR('{', 'd', 9),
  _CHR('e', 702+(-3)),
  _CHR('i', 615),
  _CHR('o', 242),
  _CHR('r', 194),
  _CHR('a', 165),
  _CHR('u', 73),
  _CHR('y', 39),
  _CHR('w', 15),
  _CHR('p', 5),
  PAIR('a', 'e', 8),
  _CHR('r', 921+(1)),
  _CHR('d', 307),
  _CHR('m', 205),
  _CHR('t', 205),
  _CHR('s', 102),
  _CHR('c', 102),
  _CHR('b', 102),
  _CHR('v', 102),
  PAIR('b', 'e', 16),
  _CHR('r', 464+(-1)),
  _CHR('l', 240),
  _CHR('a', 208),
  _CHR('d', 192),
  _CHR('{', 176),
  _CHR('s', 160),
  _CHR('n', 144),
  _CHR('h', 144),
  _CHR('t', 96),
  _CHR('e', 64),
  _CHR('i', 48),
  _CHR('c', 32),
  _CHR('v', 32),
  _CHR('g', 16),
  _CHR('j', 16),
  _CHR('f', 16),
  PAIR('c', 'e', 18),
  _CHR('{', 864),
  _CHR('n', 211),
  _CHR('r', 181),
  _CHR('d', 174),
  _CHR('p', 131),
  _CHR('s', 131),
  _CHR('l', 109),
  _CHR('a', 51),
  _CHR('f', 44),
  _CHR('i', 36),
  _CHR('m', 36),
  _CHR('w', 22),
  _CHR('t', 22),
  _CHR('c', 7),
  _CHR('b', 7),
  _CHR('q', 7),
  _CHR('u', 7),
  _CHR('h', 7),
  PAIR('d', 'e', 23),
  _CHR('r', 399+(2)),
  _CHR('{', 281),
  _CHR('n', 184),
  _CHR('s', 179),
  _CHR('d', 169),
  _CHR('c', 143),
  _CHR('l', 123),
  _CHR('f', 82),
  _CHR('m', 77),
  _CHR('v', 67),
  _CHR('t', 56),
  _CHR('b', 56),
  _CHR('p', 56),
  _CHR('a', 56),
  _CHR('o', 31),
  _CHR('e', 26),
  _CHR('g', 15),
  _CHR('x', 10),
  _CHR('i', 10),
  _CHR('w', 10),
  _CHR('q', 5),
  _CHR('j', 5),
  _CHR('h', 5),
  PAIR('e', 'e', 16),
  _CHR('p', 336+(-1)),
  _CHR('r', 272),
  _CHR('d', 256),
  _CHR('{', 224),
  _CHR('n', 176),
  _CHR('z', 160),
  _CHR('l', 128),
  _CHR('k', 96),
  _CHR('m', 96),
  _CHR('t', 80),
  _CHR('c', 64),
  _CHR('v', 64),
  _CHR('s', 48),
  _CHR('a', 16),
  _CHR('h', 16),
  _CHR('b', 16),
  PAIR('f', 'e', 13),
  _CHR('r', 500),
  _CHR('c', 333),
  _CHR('n', 238),
  _CHR('{', 167),
  _CHR('t', 143),
  _CHR('l', 119),
  _CHR('d', 119),
  _CHR('m', 95),
  _CHR('s', 95),
  _CHR('a', 95),
  _CHR('i', 71),
  _CHR('e', 48),
  _CHR('h', 24),
  PAIR('g', 'e', 18),
  _CHR('{', 633+(1)),
  _CHR('n', 395),
  _CHR('r', 340),
  _CHR('d', 202),
  _CHR('o', 83),
  _CHR('t', 64),
  _CHR('a', 64),
  _CHR('l', 64),
  _CHR('m', 55),
  _CHR('s', 55),
  _CHR('f', 28),
  _CHR('y', 9),
  _CHR('u', 9),
  _CHR('e', 9),
  _CHR('p', 9),
  _CHR('v', 9),
  _CHR('w', 9),
  _CHR('c', 9),
  PAIR('h', 'e', 18),
  _CHR('r', 535+(-2)),
  _CHR('a', 341),
  _CHR('d', 217),
  _CHR('m', 147),
  _CHR('l', 140),
  _CHR('e', 124),
  _CHR('n', 109),
  _CHR('t', 109),
  _CHR('{', 85),
  _CHR('o', 54),
  _CHR('c', 39),
  _CHR('s', 39),
  _CHR('i', 39),
  _CHR('p', 23),
  _CHR('w', 16),
  _CHR('u', 16),
  _CHR('y', 8),
  _CHR('g', 8),
  PAIR('i', 'e', 14),
  _CHR('n', 460+(1)),
  _CHR('r', 333),
  _CHR('{', 286),
  _CHR('d', 254),
  _CHR('l', 159),
  _CHR('w', 127),
  _CHR('t', 111),
  _CHR('f', 63),
  _CHR('v', 63),
  _CHR('s', 63),
  _CHR('c', 63),
  _CHR('u', 32),
  _CHR('b', 16),
  _CHR('g', 16),
  PAIR('j', 'e', 9),
  _CHR('c', 1228+(-1)),
  _CHR('w', 164),
  _CHR('a', 164),
  _CHR('t', 82),
  _CHR('e', 82),
  _CHR('s', 82),
  _CHR('r', 82),
  _CHR('{', 82),
  _CHR('l', 82),
  PAIR('k', 'e', 16),
  _CHR('r', 651+(-6)),
  _CHR('{', 388),
  _CHR('d', 295),
  _CHR('t', 264),
  _CHR('n', 171),
  _CHR('e', 62),
  _CHR('w', 47),
  _CHR('y', 47),
  _CHR('u', 16),
  _CHR('p', 16),
  _CHR('l', 16),
  _CHR('m', 16),
  _CHR('s', 16),
  _CHR('i', 16),
  _CHR('o', 16),
  _CHR('a', 16),
  PAIR('l', 'e', 22),
  _CHR('{', 766+(-1)),
  _CHR('s', 206),
  _CHR('d', 196),
  _CHR('r', 131),
  _CHR('a', 120),
  _CHR('c', 103),
  _CHR('n', 103),
  _CHR('t', 86),
  _CHR('g', 76),
  _CHR('m', 52),
  _CHR('u', 27),
  _CHR('e', 24),
  _CHR('b', 24),
  _CHR('x', 21),
  _CHR('v', 21),
  _CHR('y', 17),
  _CHR('w', 17),
  _CHR('o', 14),
  _CHR('l', 14),
  _CHR('h', 10),
  _CHR('p', 10),
  _CHR('f', 10),
  PAIR('m', 'e', 19),
  _CHR('n', 621+(1)),
  _CHR('d', 300),
  _CHR('r', 263),
  _CHR('{', 234),
  _CHR('t', 227),
  _CHR('l', 110),
  _CHR('a', 80),
  _CHR('s', 37),
  _CHR('m', 29),
  _CHR('o', 29),
  _CHR('g', 22),
  _CHR('b', 22),
  _CHR('p', 22),
  _CHR('e', 15),
  _CHR('k', 7),
  _CHR('w', 7),
  _CHR('v', 7),
  _CHR('i', 7),
  _CHR('c', 7),
  PAIR('n', 'e', 22),
  _CHR('s', 537+(2)),
  _CHR('{', 430),
  _CHR('r', 169),
  _CHR('d', 138),
  _CHR('t', 118),
  _CHR('c', 82),
  _CHR('u', 82),
  _CHR('a', 56),
  _CHR('x', 51),
  _CHR('w', 51),
  _CHR('l', 51),
  _CHR('n', 51),
  _CHR('f', 46),
  _CHR('g', 36),
  _CHR('o', 31),
  _CHR('y', 26),
  _CHR('e', 20),
  _CHR('m', 20),
  _CHR('q', 20),
  _CHR('i', 15),
  _CHR('b', 10),
  _CHR('p', 5),
  PAIR('o', 'e', 14),
  _CHR('t', 267),
  _CHR('c', 267),
  _CHR('n', 267),
  _CHR('d', 178),
  _CHR('r', 178),
  _CHR('{', 178),
  _CHR('x', 89),
  _CHR('u', 89),
  _CHR('i', 89),
  _CHR('b', 89),
  _CHR('s', 89),
  _CHR('l', 89),
  _CHR('m', 89),
  _CHR('v', 89),
  PAIR('p', 'e', 17),
  _CHR('r', 841+(2)),
  _CHR('c', 198),
  _CHR('n', 190),
  _CHR('d', 182),
  _CHR('{', 182),
  _CHR('a', 127),
  _CHR('l', 79),
  _CHR('t', 71),
  _CHR('e', 63),
  _CHR('s', 24),
  _CHR('g', 16),
  _CHR('o', 16),
  _CHR('f', 16),
  _CHR('u', 16),
  _CHR('p', 8),
  _CHR('b', 8),
  _CHR('w', 8),
  PAIR('r', 'e', 27),
  _CHR('s', 240+(-2)),
  _CHR('d', 212),
  _CHR('{', 209),
  _CHR('a', 209),
  _CHR('c', 154),
  _CHR('t', 143),
  _CHR('n', 103),
  _CHR('p', 100),
  _CHR('l', 86),
  _CHR('g', 80),
  _CHR('v', 77),
  _CHR('e', 74),
  _CHR('m', 63),
  _CHR('f', 60),
  _CHR('w', 43),
  _CHR('o', 31),
  _CHR('b', 29),
  _CHR('h', 26),
  _CHR('i', 26),
  _CHR('r', 20),
  _CHR('y', 17),
  _CHR('q', 17),
  _CHR('j', 9),
  _CHR('u', 9),
  _CHR('k', 6),
  _CHR('z', 3),
  _CHR('x', 3),
  PAIR('s', 'e', 22),
  _CHR('{', 543+(2)),
  _CHR('d', 265),
  _CHR('n', 227),
  _CHR('r', 221),
  _CHR('l', 120),
  _CHR('a', 114),
  _CHR('c', 101),
  _CHR('m', 69),
  _CHR('t', 63),
  _CHR('e', 57),
  _CHR('s', 44),
  _CHR('x', 44),
  _CHR('p', 38),
  _CHR('i', 25),
  _CHR('g', 25),
  _CHR('v', 19),
  _CHR('u', 19),
  _CHR('q', 13),
  _CHR('w', 13),
  _CHR('b', 13),
  _CHR('f', 6),
  _CHR('o', 6),
  PAIR('t', 'e', 20),
  _CHR('r', 635+(-3)),
  _CHR('{', 518),
  _CHR('d', 348),
  _CHR('n', 198),
  _CHR('l', 66),
  _CHR('e', 55),
  _CHR('a', 40),
  _CHR('m', 37),
  _CHR('c', 35),
  _CHR('s', 32),
  _CHR('f', 20),
  _CHR('x', 12),
  _CHR('u', 9),
  _CHR('o', 9),
  _CHR('g', 9),
  _CHR('p', 9),
  _CHR('t', 6),
  _CHR('b', 6),
  _CHR('w', 3),
  _CHR('h', 3),
  PAIR('u', 'e', 10),
  _CHR('{', 640),
  _CHR('s', 281),
  _CHR('n', 230),
  _CHR('l', 230),
  _CHR('t', 205),
  _CHR('r', 154),
  _CHR('e', 102),
  _CHR('a', 77),
  _CHR('d', 77),
  _CHR('b', 51),
  PAIR('v', 'e', 13),
  _CHR('r', 634+(1)),
  _CHR('{', 616),
  _CHR('n', 287),
  _CHR('l', 269),
  _CHR('d', 96),
  _CHR('s', 54),
  _CHR('t', 30),
  _CHR('m', 18),
  _CHR('i', 12),
  _CHR('g', 12),
  _CHR('e', 6),
  _CHR('x', 6),
  _CHR('b', 6),
  PAIR('w', 'e', 9),
  _CHR('r', 435),
  _CHR('l', 409),
  _CHR('e', 333),
  _CHR('d', 230),
  _CHR('a', 230),
  _CHR('i', 154),
  _CHR('b', 128),
  _CHR('s', 102),
  _CHR('p', 26),
  PAIR('x', 'e', 6),
  _CHR('n', 341+(1)),
  _CHR('r', 341),
  _CHR('c', 341),
  _CHR('d', 341),
  _CHR('t', 341),
  _CHR('g', 341),
  PAIR('y', 'e', 10),
  _CHR('r', 585+(1)),
  _CHR('l', 366),
  _CHR('d', 292),
  _CHR('n', 219),
  _CHR('a', 146),
  _CHR('s', 146),
  _CHR('g', 73),
  _CHR('h', 73),
  _CHR('{', 73),
  _CHR('e', 73),
  PAIR('z', 'e', 10),
  _CHR('d', 847+(-3)),
  _CHR('{', 847),
  _CHR('r', 118),
  _CHR('n', 94),
  _CHR('p', 24),
  _CHR('t', 24),
  _CHR('s', 24),
  _CHR('b', 24),
  _CHR('a', 24),
  _CHR('l', 24),
  PAIR('{', 'e', 22),
  _CHR('x', 456+(1)),
  _CHR('n', 448),
  _CHR('l', 157),
  _CHR('m', 157),
  _CHR('v', 120),
  _CHR('a', 105),
  _CHR('p', 97),
  _CHR('s', 90),
  _CHR('r', 60),
  _CHR('f', 52),
  _CHR('g', 52),
  _CHR('c', 45),
  _CHR('u', 37),
  _CHR('t', 37),
  _CHR('q', 30),
  _CHR('y', 30),
  _CHR('d', 22),
  _CHR('b', 15),
  _CHR('j', 15),
  _CHR('e', 7),
  _CHR('o', 7),
  _CHR('i', 7),
  PAIR('a', 'f', 9),
  _CHR('f', 910+(2)),
  _CHR('t', 591),
  _CHR('e', 182),
  _CHR('{', 91),
  _CHR('i', 91),
  _CHR('o', 45),
  _CHR('a', 45),
  _CHR('y', 45),
  _CHR('r', 45),
  PAIR('d', 'f', 3),
  _CHR('l', 1024+(-1)),
  _CHR('a', 512),
  _CHR('o', 512),
  PAIR('e', 'f', 10),
  _CHR('u', 512+(1)),
  _CHR('f', 256),
  _CHR('i', 230),
  _CHR('l', 230),
  _CHR('a', 179),
  _CHR('o', 179),
  _CHR('e', 179),
  _CHR('t', 102),
  _CHR('r', 102),
  _CHR('{', 77),
  PAIR('f', 'f', 11),
  _CHR('e', 585+(-1)),
  _CHR('{', 399),
  _CHR('i', 319),
  _CHR('l', 266),
  _CHR('o', 213),
  _CHR('a', 53),
  _CHR('y', 53),
  _CHR('s', 53),
  _CHR('u', 53),
  _CHR('h', 27),
  _CHR('r', 27),
  PAIR('g', 'f', 3),
  _CHR('u', 682+(1)),
  _CHR('i', 682),
  _CHR('l', 682),
  TRIPLE('h', 'f', 'u'),
  PAIR('i', 'f', 10),
  _CHR('i', 744+(-1)),
  _CHR('e', 326),
  _CHR('f', 279),
  _CHR('y', 233),
  _CHR('t', 186),
  _CHR('u', 93),
  _CHR('l', 70),
  _CHR('o', 47),
  _CHR('{', 47),
  _CHR('a', 23),
  PAIR('k', 'f', 3),
  _CHR('a', 819),
  _CHR('l', 819),
  _CHR('i', 409),
  PAIR('l', 'f', 5),
  _CHR('i', 682+(1)),
  _CHR('l', 341),
  _CHR('u', 341),
  _CHR('r', 341),
  _CHR('{', 341),
  TRIPLE('m', 'f', 'o'),
  PAIR('n', 'f', 7),
  _CHR('o', 501+(1)),
  _CHR('u', 376),
  _CHR('e', 292),
  _CHR('i', 292),
  _CHR('a', 209),
  _CHR('l', 209),
  _CHR('r', 167),
  PAIR('o', 'f', 9),
  _CHR('f', 903+(1)),
  _CHR('t', 241),
  _CHR('i', 241),
  _CHR('{', 241),
  _CHR('a', 120),
  _CHR('o', 120),
  _CHR('r', 60),
  _CHR('p', 60),
  _CHR('e', 60),
  TRIPLE('p', 'f', 'u'),
  PAIR('r', 'f', 8),
  _CHR('a', 585+(1)),
  _CHR('u', 468),
  _CHR('i', 234),
  _CHR('o', 234),
  _CHR('e', 175),
  _CHR('{', 175),
  _CHR('r', 117),
  _CHR('l', 58),
  PAIR('s', 'f', 6),
  _CHR('i', 630),
  _CHR('u', 315),
  _CHR('o', 315),
  _CHR('a', 315),
  _CHR('e', 315),
  _CHR('r', 157),
  PAIR('t', 'f', 2),
  _CHR('u', 1842),
  _CHR('o', 205),
  PAIR('u', 'f', 2),
  _CHR('f', 1950),
  _CHR('r', 97),
  PAIR('w', 'f', 2),
  _CHR('u', 1535),
  _CHR('o', 512),
  PAIR('x', 'f', 2),
  _CHR('u', 1024+(-1)),
  _CHR('o', 1024),
  TRIPLE('y', 'f', 'u'),
  PAIR('{', 'f', 8),
  _CHR('a', 394+(-1)),
  _CHR('o', 379),
  _CHR('l', 365),
  _CHR('i', 344),
  _CHR('r', 258),
  _CHR('e', 186),
  _CHR('u', 115),
  _CHR('j', 7),
  PAIR('a', 'g', 12),
  _CHR('e', 872+(1)),
  _CHR('i', 285),
  _CHR('n', 285),
  _CHR('g', 235),
  _CHR('o', 101),
  _CHR('{', 67),
  _CHR('r', 50),
  _CHR('m', 50),
  _CHR('a', 50),
  _CHR('p', 17),
  _CHR('f', 17),
  _CHR('l', 17),
  TRIPLE('b', 'g', 'r'),
  PAIR('d', 'g', 3),
  _CHR('e', 1694),
  _CHR('i', 282),
  _CHR('a', 71),
  PAIR('e', 'g', 10),
  _CHR('a', 476),
  _CHR('r', 428),
  _CHR('i', 357),
  _CHR('e', 238),
  _CHR('o', 238),
  _CHR('u', 119),
  _CHR('m', 71),
  _CHR('l', 48),
  _CHR('{', 48),
  _CHR('g', 24),
  PAIR('g', 'g', 6),
  _CHR('e', 784+(-1)),
  _CHR('l', 610),
  _CHR('i', 305),
  _CHR('y', 261),
  _CHR('a', 44),
  _CHR('r', 44),
  TRIPLE('h', 'g', 'o'),
  PAIR('i', 'g', 11),
  _CHR('h', 910),
  _CHR('n', 244),
  _CHR('g', 179),
  _CHR('e', 146),
  _CHR('a', 130),
  _CHR('i', 114),
  _CHR('{', 97),
  _CHR('o', 65),
  _CHR('r', 65),
  _CHR('u', 65),
  _CHR('m', 32),
  TRIPLE('k', 'g', 'r'),
  PAIR('l', 'g', 4),
  _CHR('e', 768+(-1)),
  _CHR('i', 512),
  _CHR('a', 512),
  _CHR('o', 256),
  PAIR('n', 'g', 17),
  _CHR('{', 1589+(1)),
  _CHR('l', 132),
  _CHR('e', 129),
  _CHR('u', 36),
  _CHR('i', 32),
  _CHR('r', 29),
  _CHR('o', 23),
  _CHR('s', 23),
  _CHR('a', 16),
  _CHR('h', 10),
  _CHR('b', 6),
  _CHR('y', 6),
  _CHR('m', 3),
  _CHR('w', 3),
  _CHR('f', 3),
  _CHR('t', 3),
  _CHR('c', 3),
  PAIR('o', 'g', 15),
  _CHR('i', 571),
  _CHR('r', 301),
  _CHR('y', 286),
  _CHR('e', 190),
  _CHR('g', 190),
  _CHR('n', 127),
  _CHR('{', 111),
  _CHR('u', 95),
  _CHR('o', 32),
  _CHR('m', 32),
  _CHR('l', 32),
  _CHR('a', 32),
  _CHR('b', 16),
  _CHR('s', 16),
  _CHR('f', 16),
  TRIPLE('p', 'g', 'i'),
  PAIR('r', 'g', 9),
  _CHR('e', 768+(-1)),
  _CHR('a', 448),
  _CHR('o', 224),
  _CHR('u', 160),
  _CHR('i', 128),
  _CHR('l', 128),
  _CHR('y', 96),
  _CHR('r', 64),
  _CHR('{', 32),
  PAIR('s', 'g', 2),
  _CHR('e', 1024+(-1)),
  _CHR('r', 1024),
  PAIR('t', 'g', 2),
  _CHR('u', 1365),
  _CHR('r', 682),
  PAIR('u', 'g', 9),
  _CHR('h', 866+(1)),
  _CHR('g', 354),
  _CHR('{', 236),
  _CHR('a', 197),
  _CHR('e', 197),
  _CHR('l', 79),
  _CHR('m', 39),
  _CHR('n', 39),
  _CHR('b', 39),
  PAIR('y', 'g', 6),
  _CHR('o', 682+(2)),
  _CHR('r', 455),
  _CHR('l', 227),
  _CHR('y', 227),
  _CHR('e', 227),
  _CHR('i', 227),
  PAIR('{', 'g', 10),
  _CHR('r', 571),
  _CHR('a', 325),
  _CHR('l', 299),
  _CHR('u', 272),
  _CHR('o', 228),
  _CHR('e', 211),
  _CHR('i', 114),
  _CHR('h', 9),
  _CHR('n', 9),
  _CHR('y', 9),
  PAIR('a', 'h', 5),
  _CHR('{', 1024+(-1)),
  _CHR('i', 409),
  _CHR('n', 205),
  _CHR('o', 205),
  _CHR('u', 205),
  PAIR('c', 'h', 16),
  _CHR('i', 431+(-1)),
  _CHR('a', 387),
  _CHR('{', 344),
  _CHR('e', 300),
  _CHR('o', 249),
  _CHR('r', 80),
  _CHR('u', 73),
  _CHR('y', 51),
  _CHR('n', 29),
  _CHR('b', 22),
  _CHR('l', 15),
  _CHR('m', 15),
  _CHR('h', 15),
  _CHR('d', 15),
  _CHR('s', 15),
  _CHR('c', 7),
  PAIR('d', 'h', 2),
  _CHR('a', 1024+(-1)),
  _CHR('o', 1024),
  PAIR('e', 'h', 7),
  _CHR('e', 607+(-2)),
  _CHR('a', 607),
  _CHR('o', 531),
  _CHR('u', 76),
  _CHR('y', 76),
  _CHR('{', 76),
  _CHR('i', 76),
  TRIPLE('f', 'h', 'a'),
  PAIR('g', 'h', 10),
  _CHR('t', 1573+(-1)),
  _CHR('{', 150),
  _CHR('o', 75),
  _CHR('b', 75),
  _CHR('i', 50),
  _CHR('g', 25),
  _CHR('a', 25),
  _CHR('e', 25),
  _CHR('y', 25),
  _CHR('l', 25),
  PAIR('h', 'h', 3),
  _CHR('o', 682+(1)),
  _CHR('e', 682),
  _CHR('i', 682),
  TRIPLE('i', 'h', 'i'),
  TRIPLE('k', 'h', 'a'),
  PAIR('l', 'h', 2),
  _CHR('e', 1638),
  _CHR('o', 409),
  TRIPLE('m', 'h', 'o'),
  PAIR('n', 'h', 4),
  _CHR('a', 955+(1)),
  _CHR('o', 546),
  _CHR('e', 409),
  _CHR('y', 136),
  PAIR('o', 'h', 4),
  _CHR('e', 1137+(1)),
  _CHR('i', 455),
  _CHR('o', 227),
  _CHR('a', 227),
  PAIR('p', 'h', 10),
  _CHR('o', 435),
  _CHR('i', 417),
  _CHR('y', 399),
  _CHR('a', 326),
  _CHR('e', 199),
  _CHR('{', 145),
  _CHR('t', 54),
  _CHR('u', 36),
  _CHR('l', 18),
  _CHR('r', 18),
  PAIR('r', 'h', 5),
  _CHR('e', 910+(-1)),
  _CHR('a', 569),
  _CHR('o', 341),
  _CHR('{', 114),
  _CHR('y', 114),
  PAIR('s', 'h', 14),
  _CHR('{', 469),
  _CHR('i', 430),
  _CHR('e', 297),
  _CHR('a', 258),
  _CHR('o', 249),
  _CHR('r', 105),
  _CHR('u', 67),
  _CHR('m', 48),
  _CHR('l', 38),
  _CHR('b', 19),
  _CHR('n', 19),
  _CHR('c', 19),
  _CHR('w', 19),
  _CHR('y', 10),
  PAIR('t', 'h', 16),
  _CHR('e', 735),
  _CHR('o', 298),
  _CHR('{', 298),
  _CHR('i', 195),
  _CHR('r', 186),
  _CHR('y', 84),
  _CHR('a', 56),
  _CHR('w', 37),
  _CHR('m', 37),
  _CHR('l', 28),
  _CHR('u', 28),
  _CHR('s', 19),
  _CHR('f', 19),
  _CHR('h', 9),
  _CHR('n', 9),
  _CHR('q', 9),
  PAIR('w', 'h', 3),
  _CHR('i', 918),
  _CHR('e', 847),
  _CHR('o', 282),
  PAIR('x', 'h', 3),
  _CHR('a', 1228+(1)),
  _CHR('i', 409),
  _CHR('o', 409),
  TRIPLE('y', 'h', 'o'),
  PAIR('{', 'h', 6),
  _CHR('a', 516),
  _CHR('e', 484),
  _CHR('o', 427),
  _CHR('y', 242),
  _CHR('i', 193),
  _CHR('u', 185),
  PAIR('a', 'i', 12),
  _CHR('n', 696),
  _CHR('l', 409),
  _CHR('r', 355),
  _CHR('t', 150),
  _CHR('d', 136),
  _CHR('s', 123),
  _CHR('m', 68),
  _CHR('c', 41),
  _CHR('g', 27),
  _CHR('e', 14),
  _CHR('f', 14),
  _CHR('k', 14),
  PAIR('b', 'i', 18),
  _CHR('l', 701+(2)),
  _CHR('n', 329),
  _CHR('o', 301),
  _CHR('t', 215),
  _CHR('r', 100),
  _CHR('a', 57),
  _CHR('c', 57),
  _CHR('b', 57),
  _CHR('d', 43),
  _CHR('p', 43),
  _CHR('g', 29),
  _CHR('z', 29),
  _CHR('s', 14),
  _CHR('f', 14),
  _CHR('u', 14),
  _CHR('e', 14),
  _CHR('q', 14),
  _CHR('{', 14),
  PAIR('c', 'i', 16),
  _CHR('a', 451+(5)),
  _CHR('s', 231),
  _CHR('t', 220),
  _CHR('o', 199),
  _CHR('n', 199),
  _CHR('e', 147),
  _CHR('p', 126),
  _CHR('l', 115),
  _CHR('r', 94),
  _CHR('f', 94),
  _CHR('d', 84),
  _CHR('z', 31),
  _CHR('v', 21),
  _CHR('g', 10),
  _CHR('{', 10),
  _CHR('b', 10),
  PAIR('d', 'i', 18),
  _CHR('s', 591+(-2)),
  _CHR('n', 403),
  _CHR('c', 255),
  _CHR('a', 161),
  _CHR('t', 94),
  _CHR('l', 81),
  _CHR('o', 74),
  _CHR('v', 67),
  _CHR('m', 60),
  _CHR('z', 40),
  _CHR('f', 34),
  _CHR('p', 34),
  _CHR('r', 34),
  _CHR('e', 34),
  _CHR('g', 27),
  _CHR('u', 27),
  _CHR('b', 20),
  _CHR('{', 13),
  PAIR('e', 'i', 14),
  _CHR('g', 445+(-5)),
  _CHR('n', 312),
  _CHR('s', 267),
  _CHR('v', 223),
  _CHR('t', 223),
  _CHR('r', 134),
  _CHR('l', 89),
  _CHR('f', 89),
  _CHR('o', 45),
  _CHR('a', 45),
  _CHR('d', 45),
  _CHR('z', 45),
  _CHR('m', 45),
  _CHR('{', 45),
  PAIR('f', 'i', 15),
  _CHR('c', 487+(1)),
  _CHR('e', 309),
  _CHR('r', 244),
  _CHR('n', 244),
  _CHR('l', 162),
  _CHR('g', 114),
  _CHR('t', 97),
  _CHR('s', 97),
  _CHR('d', 81),
  _CHR('a', 65),
  _CHR('x', 49),
  _CHR('b', 49),
  _CHR('y', 16),
  _CHR('f', 16),
  _CHR('z', 16),
  PAIR('g', 'i', 16),
  _CHR('c', 507+(4)),
  _CHR('n', 367),
  _CHR('s', 350),
  _CHR('o', 140),
  _CHR('t', 122),
  _CHR('a', 122),
  _CHR('v', 105),
  _CHR('e', 70),
  _CHR('l', 52),
  _CHR('r', 52),
  _CHR('b', 35),
  _CHR('m', 35),
  _CHR('d', 35),
  _CHR('g', 17),
  _CHR('f', 17),
  _CHR('z', 17),
  PAIR('h', 'i', 20),
  _CHR('n', 353),
  _CHR('p', 301),
  _CHR('c', 291),
  _CHR('l', 218),
  _CHR('s', 218),
  _CHR('t', 125),
  _CHR('e', 83),
  _CHR('r', 73),
  _CHR('o', 62),
  _CHR('g', 62),
  _CHR('{', 42),
  _CHR('d', 42),
  _CHR('m', 42),
  _CHR('a', 31),
  _CHR('v', 21),
  _CHR('k', 21),
  _CHR('b', 21),
  _CHR('f', 21),
  _CHR('j', 10),
  _CHR('z', 10),
  PAIR('j', 'i', 5),
  _CHR('n', 768+(-1)),
  _CHR('b', 512),
  _CHR('t', 256),
  _CHR('g', 256),
  _CHR('f', 256),
  PAIR('k', 'i', 11),
  _CHR('n', 1279),
  _CHR('l', 160),
  _CHR('t', 160),
  _CHR('e', 96),
  _CHR('c', 96),
  _CHR('r', 64),
  _CHR('s', 64),
  _CHR('{', 32),
  _CHR('m', 32),
  _CHR('p', 32),
  _CHR('b', 32),
  PAIR('l', 'i', 22),
  _CHR('n', 448+(1)),
  _CHR('t', 386),
  _CHR('s', 230),
  _CHR('c', 169),
  _CHR('z', 169),
  _CHR('g', 111),
  _CHR('m', 86),
  _CHR('a', 82),
  _CHR('f', 58),
  _CHR('o', 49),
  _CHR('p', 49),
  _CHR('v', 41),
  _CHR('b', 41),
  _CHR('d', 37),
  _CHR('e', 33),
  _CHR('k', 21),
  _CHR('q', 12),
  _CHR('r', 8),
  _CHR('{', 4),
  _CHR('l', 4),
  _CHR('u', 4),
  _CHR('x', 4),
  PAIR('m', 'i', 17),
  _CHR('n', 579+(-3)),
  _CHR('s', 354),
  _CHR('c', 259),
  _CHR('l', 216),
  _CHR('t', 216),
  _CHR('d', 112),
  _CHR('a', 78),
  _CHR('z', 52),
  _CHR('g', 35),
  _CHR('o', 35),
  _CHR('r', 35),
  _CHR('x', 26),
  _CHR('e', 17),
  _CHR('m', 9),
  _CHR('u', 9),
  _CHR('p', 9),
  _CHR('{', 9),
  PAIR('n', 'i', 21),
  _CHR('n', 381+(-1)),
  _CHR('s', 358),
  _CHR('c', 311),
  _CHR('t', 187),
  _CHR('z', 171),
  _CHR('a', 117),
  _CHR('f', 101),
  _CHR('o', 78),
  _CHR('v', 47),
  _CHR('m', 47),
  _CHR('e', 47),
  _CHR('g', 39),
  _CHR('p', 39),
  _CHR('k', 23),
  _CHR('b', 23),
  _CHR('l', 23),
  _CHR('h', 16),
  _CHR('d', 16),
  _CHR('u', 8),
  _CHR('q', 8),
  _CHR('{', 8),
  PAIR('o', 'i', 7),
  _CHR('d', 640+(-1)),
  _CHR('n', 416),
  _CHR('s', 384),
  _CHR('l', 320),
  _CHR('c', 192),
  _CHR('t', 64),
  _CHR('k', 32),
  PAIR('p', 'i', 19),
  _CHR('n', 587+(-3)),
  _CHR('c', 299),
  _CHR('t', 192),
  _CHR('l', 180),
  _CHR('r', 156),
  _CHR('e', 144),
  _CHR('s', 120),
  _CHR('d', 84),
  _CHR('o', 48),
  _CHR('g', 48),
  _CHR('p', 36),
  _CHR('z', 36),
  _CHR('{', 36),
  _CHR('a', 24),
  _CHR('k', 12),
  _CHR('v', 12),
  _CHR('q', 12),
  _CHR('m', 12),
  _CHR('f', 12),
  PAIR('r', 'i', 20),
  _CHR('n', 431+(2)),
  _CHR('c', 211),
  _CHR('s', 182),
  _CHR('a', 182),
  _CHR('t', 157),
  _CHR('o', 116),
  _CHR('p', 95),
  _CHR('e', 95),
  _CHR('l', 83),
  _CHR('d', 79),
  _CHR('m', 70),
  _CHR('b', 66),
  _CHR('g', 62),
  _CHR('v', 58),
  _CHR('z', 54),
  _CHR('f', 50),
  _CHR('{', 25),
  _CHR('u', 21),
  _CHR('j', 4),
  _CHR('q', 4),
  PAIR('s', 'i', 19),
  _CHR('o', 305+(2)),
  _CHR('n', 283),
  _CHR('s', 238),
  _CHR('v', 238),
  _CHR('t', 223),
  _CHR('d', 156),
  _CHR('c', 149),
  _CHR('l', 134),
  _CHR('g', 89),
  _CHR('m', 60),
  _CHR('b', 60),
  _CHR('f', 30),
  _CHR('u', 22),
  _CHR('a', 15),
  _CHR('r', 15),
  _CHR('p', 7),
  _CHR('z', 7),
  _CHR('x', 7),
  _CHR('e', 7),
  PAIR('t', 'i', 22),
  _CHR('o', 657+(3)),
  _CHR('c', 358),
  _CHR('n', 309),
  _CHR('v', 226),
  _CHR('s', 75),
  _CHR('l', 68),
  _CHR('m', 61),
  _CHR('a', 54),
  _CHR('t', 47),
  _CHR('f', 40),
  _CHR('z', 28),
  _CHR('g', 28),
  _CHR('e', 21),
  _CHR('r', 14),
  _CHR('b', 14),
  _CHR('p', 14),
  _CHR('q', 9),
  _CHR('{', 7),
  _CHR('k', 5),
  _CHR('d', 5),
  _CHR('u', 2),
  _CHR('h', 2),
  PAIR('u', 'i', 11),
  _CHR('s', 455+(-1)),
  _CHR('t', 455),
  _CHR('n', 265),
  _CHR('d', 265),
  _CHR('l', 190),
  _CHR('c', 114),
  _CHR('r', 114),
  _CHR('e', 76),
  _CHR('a', 38),
  _CHR('v', 38),
  _CHR('g', 38),
  PAIR('v', 'i', 14),
  _CHR('s', 388+(1)),
  _CHR('t', 299),
  _CHR('n', 239),
  _CHR('o', 224),
  _CHR('e', 149),
  _CHR('d', 149),
  _CHR('r', 134),
  _CHR('a', 134),
  _CHR('l', 105),
  _CHR('c', 75),
  _CHR('v', 75),
  _CHR('g', 45),
  _CHR('p', 15),
  _CHR('x', 15),
  PAIR('w', 'i', 13),
  _CHR('n', 824+(-2)),
  _CHR('t', 325),
  _CHR('s', 200),
  _CHR('d', 150),
  _CHR('g', 125),
  _CHR('c', 75),
  _CHR('p', 75),
  _CHR('r', 75),
  _CHR('f', 75),
  _CHR('l', 50),
  _CHR('z', 25),
  _CHR('x', 25),
  _CHR('m', 25),
  PAIR('x', 'i', 12),
  _CHR('d', 341),
  _CHR('c', 341),
  _CHR('s', 256),
  _CHR('o', 171),
  _CHR('l', 171),
  _CHR('m', 171),
  _CHR('n', 171),
  _CHR('a', 85),
  _CHR('b', 85),
  _CHR('f', 85),
  _CHR('t', 85),
  _CHR('{', 85),
  PAIR('y', 'i', 3),
  _CHR('n', 1791),
  _CHR('s', 128),
  _CHR('e', 128),
  PAIR('z', 'i', 5),
  _CHR('n', 1474+(-1)),
  _CHR('p', 246),
  _CHR('l', 164),
  _CHR('c', 82),
  _CHR('m', 82),
  PAIR('{', 'i', 11),
  _CHR('n', 1326),
  _CHR('m', 389),
  _CHR('r', 115),
  _CHR('s', 58),
  _CHR('c', 36),
  _CHR('g', 29),
  _CHR('d', 29),
  _CHR('l', 22),
  _CHR('o', 22),
  _CHR('t', 14),
  _CHR('p', 7),
  PAIR('a', 'j', 3),
  _CHR('a', 682+(1)),
  _CHR('o', 682),
  _CHR('u', 682),
  PAIR('b', 'j', 2),
  _CHR('e', 1638),
  _CHR('u', 409),
  TRIPLE('d', 'j', 'u'),
  PAIR('e', 'j', 2),
  _CHR('e', 1462),
  _CHR('u', 585),
  TRIPLE('f', 'j', 'o'),
  PAIR('i', 'j', 2),
  _CHR('u', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('n', 'j', 4),
  _CHR('u', 853),
  _CHR('o', 682),
  _CHR('e', 341),
  _CHR('a', 171),
  PAIR('o', 'j', 2),
  _CHR('e', 1365),
  _CHR('u', 682),
  TRIPLE('p', 'j', 'e'),
  PAIR('r', 'j', 3),
  _CHR('a', 1024+(-1)),
  _CHR('o', 512),
  _CHR('u', 512),
  TRIPLE('s', 'j', 'u'),
  TRIPLE('u', 'j', 'a'),
  PAIR('{', 'j', 5),
  _CHR('u', 660+(1)),
  _CHR('a', 594),
  _CHR('o', 330),
  _CHR('i', 231),
  _CHR('e', 231),
  PAIR('a', 'k', 9),
  _CHR('e', 1057),
  _CHR('i', 330),
  _CHR('{', 297),
  _CHR('a', 99),
  _CHR('y', 99),
  _CHR('l', 66),
  _CHR('f', 33),
  _CHR('o', 33),
  _CHR('d', 33),
  PAIR('c', 'k', 22),
  _CHR('{', 682+(-2)),
  _CHR('e', 417),
  _CHR('l', 227),
  _CHR('s', 126),
  _CHR('a', 76),
  _CHR('i', 76),
  _CHR('o', 63),
  _CHR('y', 63),
  _CHR('f', 51),
  _CHR('b', 38),
  _CHR('p', 38),
  _CHR('n', 38),
  _CHR('h', 25),
  _CHR('t', 25),
  _CHR('d', 13),
  _CHR('g', 13),
  _CHR('r', 13),
  _CHR('k', 13),
  _CHR('c', 13),
  _CHR('m', 13),
  _CHR('u', 13),
  _CHR('w', 13),
  PAIR('d', 'k', 2),
  _CHR('a', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('e', 'k', 5),
  _CHR('e', 682+(1)),
  _CHR('l', 455),
  _CHR('{', 455),
  _CHR('i', 227),
  _CHR('n', 227),
  PAIR('i', 'k', 5),
  _CHR('e', 1092+(1)),
  _CHR('{', 546),
  _CHR('i', 136),
  _CHR('a', 136),
  _CHR('o', 136),
  TRIPLE('k', 'k', 'n'),
  PAIR('l', 'k', 4),
  _CHR('{', 955+(1)),
  _CHR('i', 819),
  _CHR('y', 136),
  _CHR('e', 136),
  PAIR('n', 'k', 8),
  _CHR('{', 734+(-1)),
  _CHR('e', 541),
  _CHR('i', 232),
  _CHR('n', 154),
  _CHR('a', 116),
  _CHR('y', 116),
  _CHR('l', 116),
  _CHR('s', 39),
  PAIR('o', 'k', 8),
  _CHR('e', 735),
  _CHR('{', 630),
  _CHR('i', 210),
  _CHR('a', 105),
  _CHR('m', 105),
  _CHR('w', 105),
  _CHR('b', 105),
  _CHR('y', 52),
  TRIPLE('p', 'k', 'n'),
  PAIR('r', 'k', 11),
  _CHR('{', 942+(-2)),
  _CHR('e', 328),
  _CHR('s', 205),
  _CHR('l', 164),
  _CHR('a', 123),
  _CHR('i', 82),
  _CHR('b', 41),
  _CHR('g', 41),
  _CHR('p', 41),
  _CHR('r', 41),
  _CHR('y', 41),
  PAIR('s', 'k', 9),
  _CHR('e', 602),
  _CHR('i', 542),
  _CHR('a', 301),
  _CHR('{', 181),
  _CHR('y', 181),
  _CHR('u', 60),
  _CHR('m', 60),
  _CHR('l', 60),
  _CHR('t', 60),
  PAIR('u', 'k', 5),
  _CHR('e', 1024+(-1)),
  _CHR('{', 256),
  _CHR('i', 256),
  _CHR('o', 256),
  _CHR('a', 256),
  PAIR('w', 'k', 2),
  _CHR('e', 1024+(-1)),
  _CHR('{', 1024),
  PAIR('{', 'k', 9),
  _CHR('i', 740),
  _CHR('n', 436),
  _CHR('a', 348),
  _CHR('e', 174),
  _CHR('o', 87),
  _CHR('h', 87),
  _CHR('r', 87),
  _CHR('l', 44),
  _CHR('u', 44),
  PAIR('a', 'l', 22),
  _CHR('{', 763),
  _CHR('l', 464),
  _CHR('i', 343),
  _CHR('e', 84),
  _CHR('a', 71),
  _CHR('o', 57),
  _CHR('t', 40),
  _CHR('y', 30),
  _CHR('k', 27),
  _CHR('c', 24),
  _CHR('u', 24),
  _CHR('p', 20),
  _CHR('d', 20),
  _CHR('s', 17),
  _CHR('g', 13),
  _CHR('m', 13),
  _CHR('v', 10),
  _CHR('b', 7),
  _CHR('f', 7),
  _CHR('n', 7),
  _CHR('h', 3),
  _CHR('r', 3),
  PAIR('b', 'l', 6),
  _CHR('e', 1276),
  _CHR('y', 220),
  _CHR('i', 202),
  _CHR('a', 138),
  _CHR('o', 110),
  _CHR('u', 101),
  PAIR('c', 'l', 6),
  _CHR('a', 621),
  _CHR('e', 483),
  _CHR('o', 460),
  _CHR('u', 299),
  _CHR('i', 161),
  _CHR('y', 23),
  PAIR('d', 'l', 5),
  _CHR('e', 855+(-1)),
  _CHR('y', 642),
  _CHR('i', 306),
  _CHR('a', 153),
  _CHR('o', 92),
  PAIR('e', 'l', 19),
  _CHR('l', 366+(-2)),
  _CHR('e', 366),
  _CHR('i', 301),
  _CHR('y', 301),
  _CHR('{', 288),
  _CHR('o', 118),
  _CHR('a', 85),
  _CHR('d', 65),
  _CHR('t', 52),
  _CHR('p', 26),
  _CHR('c', 13),
  _CHR('u', 13),
  _CHR('m', 13),
  _CHR('k', 7),
  _CHR('b', 7),
  _CHR('h', 7),
  _CHR('f', 7),
  _CHR('r', 7),
  _CHR('s', 7),
  PAIR('f', 'l', 6),
  _CHR('a', 530),
  _CHR('u', 433),
  _CHR('e', 361),
  _CHR('i', 265),
  _CHR('o', 265),
  _CHR('y', 193),
  PAIR('g', 'l', 6),
  _CHR('y', 689+(1)),
  _CHR('e', 507),
  _CHR('i', 263),
  _CHR('o', 263),
  _CHR('a', 182),
  _CHR('u', 142),
  PAIR('h', 'l', 4),
  _CHR('y', 744+(1)),
  _CHR('o', 558),
  _CHR('e', 558),
  _CHR('i', 186),
  PAIR('i', 'l', 16),
  _CHR('i', 510),
  _CHR('l', 467),
  _CHR('e', 266),
  _CHR('y', 201),
  _CHR('{', 194),
  _CHR('a', 165),
  _CHR('o', 65),
  _CHR('d', 50),
  _CHR('t', 29),
  _CHR('m', 29),
  _CHR('k', 22),
  _CHR('h', 14),
  _CHR('b', 14),
  _CHR('s', 7),
  _CHR('v', 7),
  _CHR('g', 7),
  PAIR('k', 'l', 6),
  _CHR('e', 858+(1)),
  _CHR('i', 462),
  _CHR('y', 462),
  _CHR('a', 132),
  _CHR('o', 66),
  _CHR('u', 66),
  PAIR('l', 'l', 16),
  _CHR('y', 697+(2)),
  _CHR('i', 275),
  _CHR('e', 269),
  _CHR('{', 217),
  _CHR('o', 211),
  _CHR('a', 186),
  _CHR('u', 64),
  _CHR('b', 45),
  _CHR('s', 19),
  _CHR('c', 19),
  _CHR('w', 13),
  _CHR('t', 6),
  _CHR('d', 6),
  _CHR('h', 6),
  _CHR('f', 6),
  _CHR('n', 6),
  PAIR('m', 'l', 2),
  _CHR('e', 1706),
  _CHR('y', 341),
  PAIR('n', 'l', 5),
  _CHR('e', 630),
  _CHR('i', 551),
  _CHR('y', 394),
  _CHR('a', 236),
  _CHR('o', 236),
  PAIR('o', 'l', 13),
  _CHR('o', 525+(-1)),
  _CHR('i', 335),
  _CHR('l', 281),
  _CHR('e', 254),
  _CHR('y', 127),
  _CHR('a', 127),
  _CHR('d', 118),
  _CHR('{', 109),
  _CHR('u', 82),
  _CHR('t', 36),
  _CHR('v', 27),
  _CHR('b', 18),
  _CHR('p', 9),
  PAIR('p', 'l', 6),
  _CHR('a', 599+(1)),
  _CHR('e', 541),
  _CHR('i', 351),
  _CHR('o', 307),
  _CHR('u', 175),
  _CHR('y', 73),
  PAIR('r', 'l', 7),
  _CHR('i', 496+(1)),
  _CHR('e', 465),
  _CHR('y', 403),
  _CHR('o', 217),
  _CHR('a', 217),
  _CHR('{', 186),
  _CHR('d', 62),
  PAIR('s', 'l', 6),
  _CHR('y', 863),
  _CHR('e', 321),
  _CHR('i', 271),
  _CHR('a', 222),
  _CHR('o', 222),
  _CHR('u', 148),
  PAIR('t', 'l', 5),
  _CHR('y', 961+(1)),
  _CHR('e', 775),
  _CHR('i', 155),
  _CHR('o', 124),
  _CHR('a', 31),
  PAIR('u', 'l', 17),
  _CHR('a', 506+(1)),
  _CHR('t', 407),
  _CHR('l', 319),
  _CHR('{', 308),
  _CHR('e', 121),
  _CHR('s', 66),
  _CHR('i', 55),
  _CHR('c', 44),
  _CHR('n', 44),
  _CHR('k', 33),
  _CHR('g', 33),
  _CHR('b', 22),
  _CHR('p', 22),
  _CHR('d', 22),
  _CHR('f', 22),
  _CHR('m', 11),
  _CHR('o', 11),
  PAIR('w', 'l', 2),
  _CHR('e', 1024+(-1)),
  _CHR('{', 1024),
  TRIPLE('x', 'l', 'y'),
  PAIR('y', 'l', 6),
  _CHR('i', 682),
  _CHR('e', 455),
  _CHR('a', 455),
  _CHR('{', 227),
  _CHR('o', 114),
  _CHR('m', 114),
  TRIPLE('z', 'l', 'e'),
  PAIR('{', 'l', 7),
  _CHR('i', 561),
  _CHR('a', 426),
  _CHR('o', 416),
  _CHR('e', 364),
  _CHR('u', 218),
  _CHR('y', 52),
  _CHR('l', 10),
  PAIR('a', 'm', 13),
  _CHR('e', 430+(1)),
  _CHR('i', 365),
  _CHR('p', 274),
  _CHR('b', 222),
  _CHR('m', 196),
  _CHR('{', 169),
  _CHR('o', 130),
  _CHR('a', 104),
  _CHR('u', 39),
  _CHR('y', 39),
  _CHR('w', 26),
  _CHR('s', 26),
  _CHR('n', 26),
  PAIR('b', 'm', 3),
  _CHR('e', 819),
  _CHR('i', 819),
  _CHR('a', 409),
  PAIR('d', 'm', 4),
  _CHR('a', 768+(-1)),
  _CHR('o', 512),
  _CHR('e', 512),
  _CHR('i', 256),
  PAIR('e', 'm', 10),
  _CHR('e', 431+(2)),
  _CHR('a', 431),
  _CHR('o', 337),
  _CHR('i', 323),
  _CHR('b', 242),
  _CHR('p', 202),
  _CHR('{', 40),
  _CHR('m', 13),
  _CHR('l', 13),
  _CHR('u', 13),
  PAIR('g', 'm', 4),
  _CHR('e', 853+(-1)),
  _CHR('a', 853),
  _CHR('o', 171),
  _CHR('i', 171),
  PAIR('h', 'm', 4),
  _CHR('e', 1117),
  _CHR('a', 558),
  _CHR('i', 186),
  _CHR('u', 186),
  PAIR('i', 'm', 12),
  _CHR('p', 704),
  _CHR('i', 281),
  _CHR('e', 281),
  _CHR('a', 217),
  _CHR('m', 205),
  _CHR('{', 102),
  _CHR('o', 77),
  _CHR('u', 64),
  _CHR('b', 64),
  _CHR('s', 26),
  _CHR('y', 13),
  _CHR('c', 13),
  PAIR('k', 'm', 3),
  _CHR('a', 1024+(-1)),
  _CHR('o', 512),
  _CHR('e', 512),
  PAIR('l', 'm', 5),
  _CHR('{', 853+(-1)),
  _CHR('e', 512),
  _CHR('o', 341),
  _CHR('m', 171),
  _CHR('y', 171),
  PAIR('m', 'm', 6),
  _CHR('e', 617+(2)),
  _CHR('o', 422),
  _CHR('u', 357),
  _CHR('a', 357),
  _CHR('i', 227),
  _CHR('y', 65),
  PAIR('n', 'm', 4),
  _CHR('e', 1489),
  _CHR('o', 186),
  _CHR('i', 186),
  _CHR('a', 186),
  PAIR('o', 'm', 16),
  _CHR('e', 382+(1)),
  _CHR('p', 364),
  _CHR('a', 328),
  _CHR('i', 237),
  _CHR('m', 218),
  _CHR('b', 127),
  _CHR('{', 109),
  _CHR('o', 100),
  _CHR('y', 64),
  _CHR('n', 45),
  _CHR('l', 18),
  _CHR('u', 18),
  _CHR('s', 9),
  _CHR('f', 9),
  _CHR('t', 9),
  _CHR('r', 9),
  PAIR('p', 'm', 3),
  _CHR('a', 682+(1)),
  _CHR('u', 682),
  _CHR('e', 682),
  PAIR('r', 'm', 9),
  _CHR('a', 546),
  _CHR('i', 523),
  _CHR('{', 341),
  _CHR('e', 318),
  _CHR('o', 182),
  _CHR('l', 68),
  _CHR('h', 23),
  _CHR('u', 23),
  _CHR('p', 23),
  PAIR('s', 'm', 6),
  _CHR('{', 1058),
  _CHR('a', 414),
  _CHR('i', 276),
  _CHR('o', 115),
  _CHR('e', 92),
  _CHR('u', 92),
  PAIR('t', 'm', 4),
  _CHR('a', 1024+(-1)),
  _CHR('e', 682),
  _CHR('o', 171),
  _CHR('i', 171),
  PAIR('u', 'm', 13),
  _CHR('{', 498),
  _CHR('b', 332),
  _CHR('e', 295),
  _CHR('p', 295),
  _CHR('a', 166),
  _CHR('u', 92),
  _CHR('m', 92),
  _CHR('i', 74),
  _CHR('o', 55),
  _CHR('c', 37),
  _CHR('v', 37),
  _CHR('s', 37),
  _CHR('n', 37),
  TRIPLE('w', 'm', 'a'),
  TRIPLE('x', 'm', 'a'),
  PAIR('y', 'm', 8),
  _CHR('a', 682+(1)),
  _CHR('p', 546),
  _CHR('o', 205),
  _CHR('e', 205),
  _CHR('b', 136),
  _CHR('{', 136),
  _CHR('i', 68),
  _CHR('m', 68),
  TRIPLE('z', 'm', 'a'),
  PAIR('{', 'm', 6),
  _CHR('a', 674+(-1)),
  _CHR('i', 437),
  _CHR('o', 332),
  _CHR('e', 332),
  _CHR('u', 226),
  _CHR('y', 47),
  PAIR('a', 'n', 23),
  _CHR('t', 391+(6)),
  _CHR('d', 293),
  _CHR('{', 293),
  _CHR('c', 234),
  _CHR('g', 147),
  _CHR('i', 136),
  _CHR('s', 136),
  _CHR('a', 94),
  _CHR('n', 66),
  _CHR('k', 59),
  _CHR('e', 59),
  _CHR('o', 56),
  _CHR('y', 17),
  _CHR('h', 10),
  _CHR('l', 10),
  _CHR('v', 7),
  _CHR('q', 7),
  _CHR('f', 7),
  _CHR('u', 7),
  _CHR('z', 3),
  _CHR('j', 3),
  _CHR('x', 3),
  _CHR('b', 3),
  PAIR('b', 'n', 2),
  _CHR('o', 1535),
  _CHR('e', 512),
  PAIR('d', 'n', 2),
  _CHR('e', 1876),
  _CHR('o', 171),
  PAIR('e', 'n', 21),
  _CHR('t', 721+(3)),
  _CHR('c', 238),
  _CHR('e', 195),
  _CHR('d', 178),
  _CHR('{', 161),
  _CHR('s', 154),
  _CHR('i', 121),
  _CHR('a', 60),
  _CHR('o', 37),
  _CHR('g', 30),
  _CHR('l', 30),
  _CHR('u', 30),
  _CHR('n', 30),
  _CHR('v', 13),
  _CHR('j', 10),
  _CHR('f', 10),
  _CHR('r', 10),
  _CHR('h', 7),
  _CHR('b', 3),
  _CHR('m', 3),
  _CHR('y', 3),
  PAIR('g', 'n', 5),
  _CHR('e', 682),
  _CHR('i', 536),
  _CHR('o', 341),
  _CHR('{', 244),
  _CHR('a', 244),
  PAIR('h', 'n', 5),
  _CHR('o', 512+(-1)),
  _CHR('i', 512),
  _CHR('e', 512),
  _CHR('u', 256),
  _CHR('{', 256),
  PAIR('i', 'n', 24),
  _CHR('g', 1002+(-1)),
  _CHR('e', 227),
  _CHR('t', 183),
  _CHR('{', 113),
  _CHR('a', 89),
  _CHR('d', 81),
  _CHR('c', 67),
  _CHR('s', 59),
  _CHR('i', 52),
  _CHR('f', 33),
  _CHR('k', 26),
  _CHR('v', 26),
  _CHR('o', 24),
  _CHR('u', 15),
  _CHR('q', 9),
  _CHR('w', 7),
  _CHR('j', 7),
  _CHR('l', 6),
  _CHR('n', 6),
  _CHR('h', 6),
  _CHR('y', 4),
  _CHR('m', 2),
  _CHR('x', 2),
  _CHR('r', 2),
  PAIR('k', 'n', 4),
  _CHR('o', 1433),
  _CHR('e', 307),
  _CHR('i', 205),
  _CHR('a', 102),
  PAIR('l', 'n', 2),
  _CHR('e', 1755),
  _CHR('o', 292),
  PAIR('m', 'n', 5),
  _CHR('i', 682+(2)),
  _CHR('e', 682),
  _CHR('{', 227),
  _CHR('o', 227),
  _CHR('a', 227),
  PAIR('n', 'n', 6),
  _CHR('e', 1003),
  _CHR('i', 321),
  _CHR('a', 281),
  _CHR('y', 241),
  _CHR('o', 161),
  _CHR('u', 40),
  PAIR('o', 'n', 25),
  _CHR('{', 834),
  _CHR('a', 247),
  _CHR('i', 177),
  _CHR('s', 135),
  _CHR('e', 93),
  _CHR('t', 90),
  _CHR('o', 70),
  _CHR('g', 65),
  _CHR('d', 65),
  _CHR('c', 51),
  _CHR('v', 45),
  _CHR('f', 39),
  _CHR('n', 28),
  _CHR('y', 20),
  _CHR('k', 14),
  _CHR('r', 11),
  _CHR('p', 11),
  _CHR('l', 8),
  _CHR('j', 8),
  _CHR('w', 8),
  _CHR('u', 8),
  _CHR('m', 8),
  _CHR('q', 6),
  _CHR('z', 3),
  _CHR('h', 3),
  PAIR('p', 'n', 3),
  _CHR('o', 819),
  _CHR('e', 819),
  _CHR('i', 409),
  PAIR('r', 'n', 8),
  _CHR('a', 497+(1)),
  _CHR('e', 468),
  _CHR('{', 439),
  _CHR('i', 409),
  _CHR('m', 88),
  _CHR('u', 58),
  _CHR('o', 58),
  _CHR('f', 29),
  PAIR('s', 'n', 4),
  _CHR('e', 840),
  _CHR('o', 525),
  _CHR('i', 367),
  _CHR('a', 315),
  PAIR('t', 'n', 3),
  _CHR('e', 1228+(1)),
  _CHR('a', 409),
  _CHR('i', 409),
  PAIR('u', 'n', 24),
  _CHR('d', 385+(-4)),
  _CHR('c', 311),
  _CHR('t', 196),
  _CHR('i', 190),
  _CHR('a', 104),
  _CHR('e', 98),
  _CHR('k', 98),
  _CHR('s', 86),
  _CHR('g', 86),
  _CHR('p', 75),
  _CHR('r', 75),
  _CHR('f', 58),
  _CHR('n', 58),
  _CHR('b', 46),
  _CHR('l', 40),
  _CHR('h', 35),
  _CHR('o', 23),
  _CHR('{', 23),
  _CHR('m', 17),
  _CHR('v', 17),
  _CHR('w', 12),
  _CHR('q', 6),
  _CHR('z', 6),
  _CHR('j', 6),
  PAIR('w', 'n', 11),
  _CHR('{', 722+(2)),
  _CHR('e', 361),
  _CHR('s', 241),
  _CHR('i', 181),
  _CHR('g', 120),
  _CHR('p', 120),
  _CHR('o', 60),
  _CHR('f', 60),
  _CHR('b', 60),
  _CHR('l', 60),
  _CHR('w', 60),
  PAIR('y', 'n', 10),
  _CHR('a', 512+(1)),
  _CHR('c', 366),
  _CHR('o', 292),
  _CHR('e', 219),
  _CHR('t', 219),
  _CHR('d', 146),
  _CHR('g', 73),
  _CHR('x', 73),
  _CHR('i', 73),
  _CHR('y', 73),
  PAIR('{', 'n', 5),
  _CHR('o', 672+(-1)),
  _CHR('e', 594),
  _CHR('a', 438),
  _CHR('u', 188),
  _CHR('i', 156),
  PAIR('a', 'o', 2),
  _CHR('n', 1024+(-1)),
  _CHR('r', 1024),
  PAIR('b', 'o', 21),
  _CHR('o', 361),
  _CHR('r', 196),
  _CHR('u', 181),
  _CHR('t', 151),
  _CHR('x', 151),
  _CHR('a', 151),
  _CHR('n', 151),
  _CHR('l', 135),
  _CHR('w', 120),
  _CHR('d', 90),
  _CHR('b', 75),
  _CHR('s', 60),
  _CHR('y', 45),
  _CHR('g', 45),
  _CHR('m', 30),
  _CHR('{', 30),
  _CHR('e', 15),
  _CHR('i', 15),
  _CHR('c', 15),
  _CHR('f', 15),
  _CHR('h', 15),
  PAIR('c', 'o', 23),
  _CHR('n', 654),
  _CHR('m', 369),
  _CHR('r', 212),
  _CHR('l', 133),
  _CHR('u', 118),
  _CHR('p', 89),
  _CHR('o', 59),
  _CHR('d', 49),
  _CHR('a', 44),
  _CHR('c', 44),
  _CHR('g', 44),
  _CHR('s', 44),
  _CHR('v', 34),
  _CHR('t', 34),
  _CHR('{', 30),
  _CHR('h', 20),
  _CHR('b', 20),
  _CHR('w', 15),
  _CHR('f', 15),
  _CHR('y', 5),
  _CHR('z', 5),
  _CHR('i', 5),
  _CHR('e', 5),
  PAIR('d', 'o', 20),
  _CHR('w', 341+(-4)),
  _CHR('r', 198),
  _CHR('{', 198),
  _CHR('m', 180),
  _CHR('n', 144),
  _CHR('g', 144),
  _CHR('u', 144),
  _CHR('c', 144),
  _CHR('l', 144),
  _CHR('o', 126),
  _CHR('p', 54),
  _CHR('v', 36),
  _CHR('d', 36),
  _CHR('y', 36),
  _CHR('s', 36),
  _CHR('f', 18),
  _CHR('x', 18),
  _CHR('e', 18),
  _CHR('t', 18),
  _CHR('z', 18),
  PAIR('e', 'o', 14),
  _CHR('u', 335+(2)),
  _CHR('p', 335),
  _CHR('r', 223),
  _CHR('n', 223),
  _CHR('c', 186),
  _CHR('l', 149),
  _CHR('g', 149),
  _CHR('s', 149),
  _CHR('m', 74),
  _CHR('t', 74),
  _CHR('v', 37),
  _CHR('d', 37),
  _CHR('e', 37),
  _CHR('{', 37),
  PAIR('f', 'o', 13),
  _CHR('r', 1258),
  _CHR('o', 171),
  _CHR('l', 128),
  _CHR('c', 107),
  _CHR('u', 85),
  _CHR('n', 85),
  _CHR('e', 43),
  _CHR('i', 43),
  _CHR('g', 43),
  _CHR('t', 21),
  _CHR('p', 21),
  _CHR('s', 21),
  _CHR('x', 21),
  PAIR('g', 'o', 20),
  _CHR('r', 336+(-2)),
  _CHR('n', 214),
  _CHR('i', 183),
  _CHR('{', 153),
  _CHR('t', 122),
  _CHR('g', 122),
  _CHR('u', 122),
  _CHR('d', 122),
  _CHR('a', 122),
  _CHR('v', 92),
  _CHR('s', 92),
  _CHR('b', 61),
  _CHR('c', 61),
  _CHR('l', 61),
  _CHR('p', 31),
  _CHR('y', 31),
  _CHR('o', 31),
  _CHR('m', 31),
  _CHR('w', 31),
  _CHR('e', 31),
  PAIR('h', 'o', 20),
  _CHR('r', 289+(1)),
  _CHR('u', 248),
  _CHR('l', 227),
  _CHR('o', 217),
  _CHR('m', 196),
  _CHR('n', 155),
  _CHR('s', 134),
  _CHR('t', 124),
  _CHR('w', 93),
  _CHR('p', 83),
  _CHR('a', 41),
  _CHR('k', 31),
  _CHR('v', 31),
  _CHR('c', 31),
  _CHR('d', 31),
  _CHR('{', 31),
  _CHR('b', 21),
  _CHR('g', 21),
  _CHR('e', 21),
  _CHR('i', 21),
  PAIR('i', 'o', 19),
  _CHR('n', 1482+(1)),
  _CHR('u', 199),
  _CHR('l', 88),
  _CHR('r', 71),
  _CHR('t', 31),
  _CHR('m', 22),
  _CHR('g', 22),
  _CHR('s', 22),
  _CHR('c', 22),
  _CHR('p', 13),
  _CHR('d', 13),
  _CHR('b', 13),
  _CHR('a', 9),
  _CHR('e', 9),
  _CHR('w', 9),
  _CHR('{', 9),
  _CHR('f', 4),
  _CHR('h', 4),
  _CHR('x', 4),
  PAIR('j', 'o', 11),
  _CHR('y', 482+(2)),
  _CHR('i', 241),
  _CHR('c', 241),
  _CHR('u', 241),
  _CHR('r', 120),
  _CHR('g', 120),
  _CHR('{', 120),
  _CHR('s', 120),
  _CHR('v', 120),
  _CHR('l', 120),
  _CHR('k', 120),
  PAIR('k', 'o', 7),
  _CHR('n', 409),
  _CHR('r', 409),
  _CHR('{', 409),
  _CHR('p', 205),
  _CHR('l', 205),
  _CHR('f', 205),
  _CHR('t', 205),
  PAIR('l', 'o', 24),
  _CHR('g', 411),
  _CHR('w', 202),
  _CHR('n', 144),
  _CHR('r', 137),
  _CHR('c', 137),
  _CHR('t', 130),
  _CHR('a', 123),
  _CHR('o', 108),
  _CHR('p', 108),
  _CHR('u', 86),
  _CHR('d', 79),
  _CHR('s', 72),
  _CHR('v', 58),
  _CHR('y', 58),
  _CHR('i', 43),
  _CHR('q', 36),
  _CHR('m', 29),
  _CHR('{', 22),
  _CHR('b', 22),
  _CHR('l', 14),
  _CHR('z', 7),
  _CHR('x', 7),
  _CHR('e', 7),
  _CHR('h', 7),
  PAIR('m', 'o', 19),
  _CHR('n', 502+(1)),
  _CHR('r', 423),
  _CHR('l', 211),
  _CHR('u', 185),
  _CHR('d', 158),
  _CHR('t', 145),
  _CHR('o', 79),
  _CHR('c', 66),
  _CHR('i', 53),
  _CHR('g', 53),
  _CHR('p', 40),
  _CHR('a', 40),
  _CHR('e', 13),
  _CHR('k', 13),
  _CHR('w', 13),
  _CHR('v', 13),
  _CHR('b', 13),
  _CHR('{', 13),
  _CHR('s', 13),
  PAIR('n', 'o', 20),
  _CHR('t', 275+(1)),
  _CHR('n', 275),
  _CHR('u', 225),
  _CHR('w', 200),
  _CHR('r', 200),
  _CHR('m', 137),
  _CHR('l', 112),
  _CHR('p', 100),
  _CHR('s', 87),
  _CHR('o', 75),
  _CHR('b', 62),
  _CHR('i', 62),
  _CHR('{', 50),
  _CHR('c', 50),
  _CHR('v', 50),
  _CHR('d', 25),
  _CHR('e', 25),
  _CHR('z', 12),
  _CHR('h', 12),
  _CHR('g', 12),
  PAIR('o', 'o', 14),
  _CHR('t', 320+(-1)),
  _CHR('k', 320),
  _CHR('d', 281),
  _CHR('m', 192),
  _CHR('l', 166),
  _CHR('n', 166),
  _CHR('p', 154),
  _CHR('r', 115),
  _CHR('s', 90),
  _CHR('{', 90),
  _CHR('f', 77),
  _CHR('z', 51),
  _CHR('v', 13),
  _CHR('b', 13),
  PAIR('p', 'o', 20),
  _CHR('s', 443+(3)),
  _CHR('r', 365),
  _CHR('l', 321),
  _CHR('t', 188),
  _CHR('n', 177),
  _CHR('i', 77),
  _CHR('o', 77),
  _CHR('w', 77),
  _CHR('u', 55),
  _CHR('m', 44),
  _CHR('p', 44),
  _CHR('d', 44),
  _CHR('{', 33),
  _CHR('x', 22),
  _CHR('k', 22),
  _CHR('v', 11),
  _CHR('c', 11),
  _CHR('g', 11),
  _CHR('e', 11),
  _CHR('a', 11),
  PAIR('r', 'o', 26),
  _CHR('u', 239+(-3)),
  _CHR('p', 190),
  _CHR('s', 156),
  _CHR('n', 151),
  _CHR('m', 141),
  _CHR('o', 136),
  _CHR('b', 127),
  _CHR('w', 127),
  _CHR('t', 112),
  _CHR('l', 93),
  _CHR('c', 88),
  _CHR('g', 73),
  _CHR('i', 68),
  _CHR('v', 63),
  _CHR('a', 54),
  _CHR('f', 49),
  _CHR('d', 49),
  _CHR('{', 44),
  _CHR('j', 15),
  _CHR('r', 15),
  _CHR('x', 15),
  _CHR('e', 15),
  _CHR('k', 10),
  _CHR('y', 10),
  _CHR('z', 5),
  _CHR('h', 5),
  PAIR('s', 'o', 19),
  _CHR('n', 350+(5)),
  _CHR('c', 280),
  _CHR('r', 280),
  _CHR('m', 192),
  _CHR('u', 192),
  _CHR('l', 192),
  _CHR('d', 87),
  _CHR('b', 70),
  _CHR('{', 70),
  _CHR('a', 52),
  _CHR('g', 52),
  _CHR('f', 52),
  _CHR('p', 35),
  _CHR('o', 35),
  _CHR('t', 35),
  _CHR('y', 17),
  _CHR('e', 17),
  _CHR('w', 17),
  _CHR('s', 17),
  PAIR('t', 'o', 21),
  _CHR('r', 727+(1)),
  _CHR('n', 209),
  _CHR('m', 201),
  _CHR('u', 125),
  _CHR('p', 109),
  _CHR('l', 109),
  _CHR('c', 100),
  _CHR('{', 67),
  _CHR('w', 67),
  _CHR('g', 58),
  _CHR('o', 58),
  _CHR('i', 42),
  _CHR('x', 33),
  _CHR('b', 33),
  _CHR('s', 33),
  _CHR('k', 17),
  _CHR('t', 17),
  _CHR('e', 17),
  _CHR('y', 8),
  _CHR('f', 8),
  _CHR('z', 8),
  PAIR('u', 'o', 6),
  _CHR('r', 819+(1)),
  _CHR('u', 546),
  _CHR('t', 273),
  _CHR('d', 136),
  _CHR('s', 136),
  _CHR('x', 136),
  PAIR('v', 'o', 12),
  _CHR('l', 379+(-1)),
  _CHR('c', 341),
  _CHR('r', 341),
  _CHR('i', 227),
  _CHR('u', 152),
  _CHR('y', 114),
  _CHR('t', 114),
  _CHR('m', 114),
  _CHR('{', 76),
  _CHR('w', 76),
  _CHR('k', 76),
  _CHR('d', 38),
  PAIR('w', 'o', 7),
  _CHR('r', 1160),
  _CHR('o', 375),
  _CHR('m', 205),
  _CHR('n', 205),
  _CHR('u', 34),
  _CHR('v', 34),
  _CHR('w', 34),
  PAIR('x', 'o', 3),
  _CHR('r', 1024+(-1)),
  _CHR('n', 512),
  _CHR('t', 512),
  PAIR('y', 'o', 8),
  _CHR('n', 768+(-1)),
  _CHR('g', 384),
  _CHR('p', 256),
  _CHR('l', 128),
  _CHR('i', 128),
  _CHR('d', 128),
  _CHR('u', 128),
  _CHR('v', 128),
  PAIR('z', 'o', 5),
  _CHR('o', 819+(-1)),
  _CHR('n', 614),
  _CHR('a', 205),
  _CHR('l', 205),
  _CHR('{', 205),
  PAIR('{', 'o', 21),
  _CHR('v', 443+(2)),
  _CHR('r', 365),
  _CHR('p', 222),
  _CHR('b', 196),
  _CHR('u', 143),
  _CHR('s', 117),
  _CHR('f', 91),
  _CHR('c', 78),
  _CHR('n', 78),
  _CHR('d', 52),
  _CHR('m', 52),
  _CHR('t', 39),
  _CHR('x', 39),
  _CHR('l', 26),
  _CHR('i', 26),
  _CHR('y', 13),
  _CHR('e', 13),
  _CHR('w', 13),
  _CHR('o', 13),
  _CHR('a', 13),
  _CHR('k', 13),
  PAIR('a', 'p', 15),
  _CHR('p', 454+(-2)),
  _CHR('h', 368),
  _CHR('{', 245),
  _CHR('e', 233),
  _CHR('i', 159),
  _CHR('a', 135),
  _CHR('t', 135),
  _CHR('o', 123),
  _CHR('s', 61),
  _CHR('y', 37),
  _CHR('l', 25),
  _CHR('w', 25),
  _CHR('r', 25),
  _CHR('n', 12),
  _CHR('u', 12),
  TRIPLE('b', 'p', 'a'),
  PAIR('d', 'p', 5),
  _CHR('i', 768+(-1)),
  _CHR('a', 512),
  _CHR('l', 256),
  _CHR('o', 256),
  _CHR('e', 256),
  PAIR('e', 'p', 17),
  _CHR('t', 436+(-1)),
  _CHR('l', 268),
  _CHR('a', 268),
  _CHR('i', 252),
  _CHR('r', 235),
  _CHR('{', 101),
  _CHR('o', 101),
  _CHR('e', 84),
  _CHR('h', 84),
  _CHR('u', 50),
  _CHR('w', 50),
  _CHR('p', 34),
  _CHR('y', 17),
  _CHR('d', 17),
  _CHR('b', 17),
  _CHR('s', 17),
  _CHR('n', 17),
  TRIPLE('f', 'p', 'r'),
  TRIPLE('g', 'p', 'o'),
  PAIR('i', 'p', 17),
  _CHR('{', 469),
  _CHR('p', 319),
  _CHR('e', 244),
  _CHR('a', 225),
  _CHR('t', 188),
  _CHR('l', 169),
  _CHR('i', 75),
  _CHR('s', 75),
  _CHR('h', 56),
  _CHR('o', 56),
  _CHR('r', 38),
  _CHR('m', 38),
  _CHR('w', 19),
  _CHR('f', 19),
  _CHR('k', 19),
  _CHR('u', 19),
  _CHR('c', 19),
  PAIR('k', 'p', 2),
  _CHR('o', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('l', 'p', 6),
  _CHR('f', 630+(1)),
  _CHR('h', 472),
  _CHR('o', 315),
  _CHR('r', 315),
  _CHR('i', 157),
  _CHR('a', 157),
  PAIR('m', 'p', 13),
  _CHR('l', 341),
  _CHR('a', 341),
  _CHR('e', 302),
  _CHR('o', 223),
  _CHR('{', 210),
  _CHR('t', 171),
  _CHR('r', 171),
  _CHR('i', 105),
  _CHR('u', 105),
  _CHR('s', 26),
  _CHR('h', 26),
  _CHR('n', 13),
  _CHR('y', 13),
  PAIR('n', 'p', 6),
  _CHR('r', 862),
  _CHR('o', 431),
  _CHR('l', 323),
  _CHR('a', 215),
  _CHR('e', 108),
  _CHR('u', 108),
  PAIR('o', 'p', 16),
  _CHR('e', 399+(2)),
  _CHR('h', 283),
  _CHR('{', 232),
  _CHR('o', 206),
  _CHR('p', 193),
  _CHR('i', 180),
  _CHR('a', 154),
  _CHR('y', 77),
  _CHR('s', 64),
  _CHR('l', 64),
  _CHR('r', 64),
  _CHR('t', 51),
  _CHR('u', 39),
  _CHR('m', 13),
  _CHR('j', 13),
  _CHR('g', 13),
  PAIR('p', 'p', 8),
  _CHR('e', 492+(-1)),
  _CHR('r', 415),
  _CHR('i', 415),
  _CHR('l', 311),
  _CHR('o', 233),
  _CHR('a', 104),
  _CHR('y', 52),
  _CHR('u', 26),
  PAIR('r', 'p', 12),
  _CHR('h', 396+(1)),
  _CHR('o', 330),
  _CHR('r', 330),
  _CHR('e', 231),
  _CHR('a', 231),
  _CHR('i', 165),
  _CHR('l', 99),
  _CHR('{', 99),
  _CHR('t', 66),
  _CHR('y', 33),
  _CHR('s', 33),
  _CHR('u', 33),
  PAIR('s', 'p', 10),
  _CHR('e', 498+(1)),
  _CHR('i', 415),
  _CHR('a', 360),
  _CHR('o', 290),
  _CHR('l', 166),
  _CHR('h', 97),
  _CHR('r', 83),
  _CHR('y', 55),
  _CHR('{', 41),
  _CHR('u', 41),
  PAIR('t', 'p', 3),
  _CHR('a', 682+(1)),
  _CHR('l', 682),
  _CHR('r', 682),
  PAIR('u', 'p', 16),
  _CHR('e', 512+(3)),
  _CHR('{', 284),
  _CHR('p', 227),
  _CHR('t', 199),
  _CHR('r', 142),
  _CHR('s', 142),
  _CHR('i', 142),
  _CHR('l', 114),
  _CHR('w', 57),
  _CHR('o', 57),
  _CHR('h', 28),
  _CHR('f', 28),
  _CHR('a', 28),
  _CHR('u', 28),
  _CHR('y', 28),
  _CHR('d', 28),
  PAIR('w', 'p', 3),
  _CHR('o', 1024+(-1)),
  _CHR('i', 512),
  _CHR('a', 512),
  PAIR('x', 'p', 7),
  _CHR('l', 491),
  _CHR('e', 409),
  _CHR('a', 409),
  _CHR('i', 328),
  _CHR('o', 164),
  _CHR('r', 164),
  _CHR('u', 82),
  PAIR('y', 'p', 7),
  _CHR('e', 887+(1)),
  _CHR('o', 341),
  _CHR('t', 273),
  _CHR('h', 205),
  _CHR('i', 136),
  _CHR('n', 136),
  _CHR('l', 68),
  TRIPLE('z', 'p', 'a'),
  PAIR('{', 'p', 10),
  _CHR('r', 577),
  _CHR('a', 372),
  _CHR('o', 263),
  _CHR('e', 244),
  _CHR('i', 175),
  _CHR('l', 142),
  _CHR('u', 124),
  _CHR('h', 91),
  _CHR('s', 44),
  _CHR('y', 15),
  TRIPLE('a', 'q', 'u'),
  TRIPLE('c', 'q', 'u'),
  TRIPLE('d', 'q', 'u'),
  TRIPLE('e', 'q', 'u'),
  TRIPLE('h', 'q', 'u'),
  TRIPLE('i', 'q', 'u'),
  TRIPLE('n', 'q', 'u'),
  TRIPLE('o', 'q', 'u'),
  TRIPLE('r', 'q', 'u'),
  TRIPLE('s', 'q', 'u'),
  TRIPLE('{', 'q', 'u'),
  PAIR('a', 'r', 23),
  _CHR('i', 222+(3)),
  _CHR('d', 202),
  _CHR('{', 195),
  _CHR('t', 171),
  _CHR('y', 167),
  _CHR('a', 163),
  _CHR('r', 152),
  _CHR('e', 132),
  _CHR('c', 105),
  _CHR('m', 93),
  _CHR('l', 82),
  _CHR('k', 62),
  _CHR('b', 58),
  _CHR('g', 58),
  _CHR('n', 54),
  _CHR('p', 35),
  _CHR('s', 27),
  _CHR('o', 23),
  _CHR('f', 19),
  _CHR('h', 8),
  _CHR('v', 8),
  _CHR('z', 4),
  _CHR('q', 4),
  PAIR('b', 'r', 6),
  _CHR('a', 644),
  _CHR('o', 460),
  _CHR('i', 437),
  _CHR('e', 322),
  _CHR('u', 115),
  _CHR('y', 69),
  PAIR('c', 'r', 6),
  _CHR('e', 502),
  _CHR('o', 476),
  _CHR('a', 425),
  _CHR('i', 348),
  _CHR('u', 180),
  _CHR('y', 116),
  PAIR('d', 'r', 6),
  _CHR('o', 682),
  _CHR('a', 404),
  _CHR('i', 354),
  _CHR('e', 354),
  _CHR('u', 202),
  _CHR('y', 51),
  PAIR('e', 'r', 25),
  _CHR('{', 747),
  _CHR('i', 197),
  _CHR('a', 136),
  _CHR('e', 128),
  _CHR('s', 96),
  _CHR('o', 80),
  _CHR('c', 80),
  _CHR('t', 63),
  _CHR('y', 59),
  _CHR('m', 57),
  _CHR('v', 54),
  _CHR('l', 52),
  _CHR('n', 50),
  _CHR('p', 46),
  _CHR('r', 46),
  _CHR('f', 42),
  _CHR('g', 31),
  _CHR('b', 25),
  _CHR('w', 17),
  _CHR('d', 13),
  _CHR('h', 10),
  _CHR('j', 6),
  _CHR('u', 6),
  _CHR('k', 4),
  _CHR('z', 2),
  PAIR('f', 'r', 6),
  _CHR('a', 709+(-1)),
  _CHR('o', 512),
  _CHR('e', 394),
  _CHR('i', 276),
  _CHR('u', 118),
  _CHR('y', 39),
  PAIR('g', 'r', 5),
  _CHR('a', 1151),
  _CHR('o', 336),
  _CHR('e', 320),
  _CHR('u', 128),
  _CHR('i', 112),
  PAIR('h', 'r', 5),
  _CHR('o', 809+(1)),
  _CHR('e', 476),
  _CHR('i', 333),
  _CHR('a', 238),
  _CHR('u', 190),
  PAIR('i', 'r', 19),
  _CHR('e', 379+(1)),
  _CHR('i', 182),
  _CHR('r', 167),
  _CHR('a', 167),
  _CHR('d', 152),
  _CHR('c', 152),
  _CHR('l', 121),
  _CHR('{', 121),
  _CHR('m', 106),
  _CHR('s', 91),
  _CHR('t', 76),
  _CHR('u', 76),
  _CHR('w', 61),
  _CHR('p', 45),
  _CHR('o', 45),
  _CHR('y', 30),
  _CHR('k', 30),
  _CHR('f', 30),
  _CHR('v', 15),
  PAIR('k', 'r', 2),
  _CHR('a', 1535),
  _CHR('y', 512),
  TRIPLE('l', 'r', 'y'),
  TRIPLE('m', 'r', 'a'),
  PAIR('n', 'r', 5),
  _CHR('e', 1267+(1)),
  _CHR('o', 292),
  _CHR('u', 195),
  _CHR('a', 195),
  _CHR('i', 97),
  PAIR('o', 'r', 21),
  _CHR('{', 283),
  _CHR('i', 228),
  _CHR('e', 224),
  _CHR('t', 219),
  _CHR('a', 156),
  _CHR('k', 118),
  _CHR('m', 118),
  _CHR('d', 110),
  _CHR('y', 89),
  _CHR('p', 76),
  _CHR('g', 76),
  _CHR('n', 72),
  _CHR('r', 68),
  _CHR('o', 51),
  _CHR('s', 46),
  _CHR('c', 42),
  _CHR('b', 30),
  _CHR('l', 25),
  _CHR('u', 8),
  _CHR('w', 4),
  _CHR('j', 4),
  PAIR('p', 'r', 5),
  _CHR('o', 861+(-1)),
  _CHR('e', 769),
  _CHR('i', 317),
  _CHR('a', 84),
  _CHR('u', 17),
  PAIR('r', 'r', 8),
  _CHR('e', 507),
  _CHR('i', 507),
  _CHR('a', 324),
  _CHR('o', 243),
  _CHR('y', 223),
  _CHR('u', 122),
  _CHR('h', 101),
  _CHR('{', 20),
  PAIR('s', 'r', 3),
  _CHR('o', 877),
  _CHR('u', 585),
  _CHR('e', 585),
  PAIR('t', 'r', 6),
  _CHR('a', 704),
  _CHR('i', 510),
  _CHR('o', 330),
  _CHR('u', 201),
  _CHR('e', 180),
  _CHR('y', 122),
  PAIR('u', 'r', 21),
  _CHR('e', 329),
  _CHR('i', 236),
  _CHR('a', 227),
  _CHR('g', 135),
  _CHR('n', 126),
  _CHR('o', 118),
  _CHR('{', 110),
  _CHR('r', 101),
  _CHR('t', 101),
  _CHR('p', 84),
  _CHR('b', 84),
  _CHR('s', 84),
  _CHR('f', 67),
  _CHR('l', 51),
  _CHR('c', 42),
  _CHR('d', 34),
  _CHR('m', 34),
  _CHR('v', 25),
  _CHR('y', 25),
  _CHR('k', 17),
  _CHR('u', 17),
  TRIPLE('v', 'r', 'e'),
  PAIR('w', 'r', 5),
  _CHR('i', 862+(-1)),
  _CHR('e', 539),
  _CHR('a', 431),
  _CHR('y', 108),
  _CHR('o', 108),
  PAIR('y', 'r', 5),
  _CHR('o', 819+(-1)),
  _CHR('i', 614),
  _CHR('u', 205),
  _CHR('r', 205),
  _CHR('a', 205),
  PAIR('{', 'r', 7),
  _CHR('e', 1281),
  _CHR('a', 296),
  _CHR('o', 219),
  _CHR('i', 120),
  _CHR('u', 93),
  _CHR('h', 33),
  _CHR('y', 5),
  PAIR('a', 's', 16),
  _CHR('t', 516+(1)),
  _CHR('s', 516),
  _CHR('h', 226),
  _CHR('e', 185),
  _CHR('i', 137),
  _CHR('p', 81),
  _CHR('o', 73),
  _CHR('c', 56),
  _CHR('k', 48),
  _CHR('y', 48),
  _CHR('a', 40),
  _CHR('{', 40),
  _CHR('m', 40),
  _CHR('q', 16),
  _CHR('b', 16),
  _CHR('u', 8),
  PAIR('b', 's', 8),
  _CHR('t', 776),
  _CHR('i', 353),
  _CHR('o', 282),
  _CHR('e', 282),
  _CHR('c', 141),
  _CHR('u', 71),
  _CHR('l', 71),
  _CHR('p', 71),
  TRIPLE('c', 's', '{'),
  PAIR('d', 's', 11),
  _CHR('t', 390+(3)),
  _CHR('{', 390),
  _CHR('h', 292),
  _CHR('c', 195),
  _CHR('m', 195),
  _CHR('o', 97),
  _CHR('u', 97),
  _CHR('i', 97),
  _CHR('p', 97),
  _CHR('e', 97),
  _CHR('w', 97),
  PAIR('e', 's', 16),
  _CHR('s', 1006+(-1)),
  _CHR('t', 401),
  _CHR('e', 112),
  _CHR('i', 107),
  _CHR('c', 86),
  _CHR('{', 56),
  _CHR('p', 56),
  _CHR('h', 41),
  _CHR('o', 41),
  _CHR('a', 41),
  _CHR('u', 36),
  _CHR('m', 25),
  _CHR('q', 15),
  _CHR('k', 15),
  _CHR('y', 5),
  _CHR('b', 5),
  PAIR('f', 's', 2),
  _CHR('h', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('g', 's', 7),
  _CHR('t', 512+(-1)),
  _CHR('r', 256),
  _CHR('p', 256),
  _CHR('l', 256),
  _CHR('e', 256),
  _CHR('{', 256),
  _CHR('h', 256),
  PAIR('h', 's', 3),
  _CHR('a', 1024+(-1)),
  _CHR('t', 512),
  _CHR('{', 512),
  PAIR('i', 's', 22),
  _CHR('t', 684),
  _CHR('h', 247),
  _CHR('e', 206),
  _CHR('m', 202),
  _CHR('{', 162),
  _CHR('s', 121),
  _CHR('i', 89),
  _CHR('o', 69),
  _CHR('c', 61),
  _CHR('a', 57),
  _CHR('p', 45),
  _CHR('r', 16),
  _CHR('f', 16),
  _CHR('k', 16),
  _CHR('d', 12),
  _CHR('q', 8),
  _CHR('u', 8),
  _CHR('l', 8),
  _CHR('n', 8),
  _CHR('b', 4),
  _CHR('j', 4),
  _CHR('g', 4),
  PAIR('k', 's', 8),
  _CHR('t', 768+(-1)),
  _CHR('c', 256),
  _CHR('p', 256),
  _CHR('i', 256),
  _CHR('m', 128),
  _CHR('{', 128),
  _CHR('a', 128),
  _CHR('h', 128),
  PAIR('l', 's', 8),
  _CHR('i', 512+(-1)),
  _CHR('{', 384),
  _CHR('a', 384),
  _CHR('p', 256),
  _CHR('e', 128),
  _CHR('t', 128),
  _CHR('k', 128),
  _CHR('h', 128),
  PAIR('m', 's', 5),
  _CHR('t', 585+(1)),
  _CHR('a', 585),
  _CHR('c', 292),
  _CHR('y', 292),
  _CHR('i', 292),
  PAIR('n', 's', 18),
  _CHR('t', 389+(1)),
  _CHR('i', 389),
  _CHR('e', 223),
  _CHR('u', 189),
  _CHR('p', 145),
  _CHR('a', 122),
  _CHR('h', 111),
  _CHR('o', 100),
  _CHR('c', 100),
  _CHR('f', 78),
  _CHR('{', 45),
  _CHR('m', 45),
  _CHR('l', 33),
  _CHR('w', 22),
  _CHR('y', 22),
  _CHR('g', 11),
  _CHR('k', 11),
  _CHR('s', 11),
  PAIR('o', 's', 15),
  _CHR('t', 465+(3)),
  _CHR('e', 399),
  _CHR('i', 332),
  _CHR('c', 199),
  _CHR('s', 186),
  _CHR('p', 146),
  _CHR('a', 93),
  _CHR('m', 66),
  _CHR('{', 53),
  _CHR('o', 40),
  _CHR('l', 13),
  _CHR('h', 13),
  _CHR('w', 13),
  _CHR('u', 13),
  _CHR('y', 13),
  PAIR('p', 's', 13),
  _CHR('y', 702+(5)),
  _CHR('e', 409),
  _CHR('t', 292),
  _CHR('i', 117),
  _CHR('w', 58),
  _CHR('q', 58),
  _CHR('h', 58),
  _CHR('u', 58),
  _CHR('c', 58),
  _CHR('o', 58),
  _CHR('k', 58),
  _CHR('m', 58),
  _CHR('{', 58),
  PAIR('r', 's', 9),
  _CHR('e', 563),
  _CHR('i', 256),
  _CHR('t', 256),
  _CHR('{', 230),
  _CHR('h', 179),
  _CHR('o', 179),
  _CHR('a', 154),
  _CHR('p', 128),
  _CHR('u', 102),
  PAIR('s', 's', 17),
  _CHR('{', 1027+(4)),
  _CHR('i', 318),
  _CHR('e', 227),
  _CHR('a', 143),
  _CHR('o', 84),
  _CHR('l', 52),
  _CHR('n', 45),
  _CHR('u', 39),
  _CHR('p', 19),
  _CHR('y', 19),
  _CHR('r', 13),
  _CHR('t', 13),
  _CHR('f', 13),
  _CHR('b', 13),
  _CHR('c', 6),
  _CHR('h', 6),
  _CHR('w', 6),
  PAIR('t', 's', 11),
  _CHR('{', 487+(3)),
  _CHR('e', 292),
  _CHR('t', 195),
  _CHR('u', 195),
  _CHR('w', 195),
  _CHR('m', 195),
  _CHR('y', 97),
  _CHR('h', 97),
  _CHR('i', 97),
  _CHR('o', 97),
  _CHR('c', 97),
  PAIR('u', 's', 16),
  _CHR('{', 777+(-2)),
  _CHR('t', 298),
  _CHR('e', 225),
  _CHR('l', 218),
  _CHR('i', 174),
  _CHR('h', 94),
  _CHR('n', 51),
  _CHR('s', 51),
  _CHR('a', 29),
  _CHR('y', 29),
  _CHR('k', 29),
  _CHR('c', 22),
  _CHR('u', 15),
  _CHR('q', 15),
  _CHR('p', 15),
  _CHR('b', 7),
  PAIR('w', 's', 9),
  _CHR('t', 341+(-2)),
  _CHR('e', 341),
  _CHR('{', 341),
  _CHR('p', 171),
  _CHR('s', 171),
  _CHR('m', 171),
  _CHR('i', 171),
  _CHR('h', 171),
  _CHR('y', 171),
  PAIR('y', 's', 6),
  _CHR('i', 1024),
  _CHR('t', 783),
  _CHR('a', 60),
  _CHR('e', 60),
  _CHR('m', 60),
  _CHR('p', 60),
  PAIR('{', 's', 16),
  _CHR('t', 308+(-4)),
  _CHR('u', 251),
  _CHR('h', 196),
  _CHR('p', 191),
  _CHR('e', 183),
  _CHR('c', 157),
  _CHR('a', 144),
  _CHR('o', 115),
  _CHR('l', 97),
  _CHR('i', 97),
  _CHR('w', 84),
  _CHR('y', 63),
  _CHR('n', 60),
  _CHR('k', 37),
  _CHR('q', 37),
  _CHR('m', 31),
  PAIR('a', 't', 17),
  _CHR('i', 804+(-1)),
  _CHR('e', 613),
  _CHR('o', 139),
  _CHR('h', 124),
  _CHR('{', 84),
  _CHR('t', 75),
  _CHR('u', 58),
  _CHR('r', 49),
  _CHR('a', 32),
  _CHR('c', 20),
  _CHR('s', 14),
  _CHR('b', 9),
  _CHR('w', 9),
  _CHR('n', 9),
  _CHR('m', 3),
  _CHR('g', 3),
  _CHR('l', 3),
  PAIR('b', 't', 4),
  _CHR('e', 682+(1)),
  _CHR('u', 682),
  _CHR('{', 341),
  _CHR('l', 341),
  PAIR('c', 't', 10),
  _CHR('i', 879+(-1)),
  _CHR('{', 246),
  _CHR('e', 225),
  _CHR('o', 204),
  _CHR('a', 182),
  _CHR('u', 161),
  _CHR('r', 118),
  _CHR('f', 11),
  _CHR('m', 11),
  _CHR('l', 11),
  PAIR('d', 't', 2),
  _CHR('h', 1024+(-1)),
  _CHR('a', 1024),
  PAIR('e', 't', 18),
  _CHR('{', 422+(3)),
  _CHR('i', 357),
  _CHR('e', 260),
  _CHR('a', 227),
  _CHR('r', 203),
  _CHR('t', 146),
  _CHR('h', 122),
  _CHR('o', 89),
  _CHR('c', 41),
  _CHR('u', 41),
  _CHR('w', 32),
  _CHR('y', 24),
  _CHR('m', 24),
  _CHR('b', 16),
  _CHR('z', 16),
  _CHR('l', 8),
  _CHR('s', 8),
  _CHR('f', 8),
  PAIR('f', 't', 7),
  _CHR('{', 988+(-1)),
  _CHR('e', 494),
  _CHR('w', 212),
  _CHR('y', 141),
  _CHR('a', 71),
  _CHR('i', 71),
  _CHR('h', 71),
  TRIPLE('g', 't', 'h'),
  PAIR('h', 't', 13),
  _CHR('{', 899+(1)),
  _CHR('e', 496),
  _CHR('h', 124),
  _CHR('f', 93),
  _CHR('a', 62),
  _CHR('l', 62),
  _CHR('s', 62),
  _CHR('y', 62),
  _CHR('i', 62),
  _CHR('n', 31),
  _CHR('w', 31),
  _CHR('b', 31),
  _CHR('m', 31),
  PAIR('i', 't', 17),
  _CHR('y', 530+(1)),
  _CHR('i', 338),
  _CHR('e', 265),
  _CHR('a', 260),
  _CHR('{', 166),
  _CHR('u', 104),
  _CHR('h', 99),
  _CHR('t', 88),
  _CHR('c', 68),
  _CHR('o', 52),
  _CHR('r', 26),
  _CHR('m', 10),
  _CHR('l', 10),
  _CHR('s', 10),
  _CHR('z', 10),
  _CHR('n', 5),
  _CHR('b', 5),
  PAIR('k', 't', 3),
  _CHR('a', 682+(1)),
  _CHR('h', 682),
  _CHR('o', 682),
  PAIR('l', 't', 11),
  _CHR('i', 589+(1)),
  _CHR('{', 434),
  _CHR('a', 186),
  _CHR('u', 186),
  _CHR('y', 186),
  _CHR('e', 155),
  _CHR('h', 93),
  _CHR('r', 62),
  _CHR('z', 62),
  _CHR('o', 62),
  _CHR('w', 31),
  TRIPLE('m', 't', 'o'),
  PAIR('n', 't', 13),
  _CHR('{', 633+(1)),
  _CHR('e', 426),
  _CHR('i', 397),
  _CHR('a', 203),
  _CHR('r', 124),
  _CHR('l', 103),
  _CHR('h', 62),
  _CHR('o', 45),
  _CHR('u', 29),
  _CHR('y', 12),
  _CHR('z', 4),
  _CHR('s', 4),
  _CHR('f', 4),
  PAIR('o', 't', 17),
  _CHR('{', 435+(-1)),
  _CHR('h', 306),
  _CHR('i', 294),
  _CHR('e', 271),
  _CHR('o', 188),
  _CHR('t', 118),
  _CHR('a', 82),
  _CHR('c', 82),
  _CHR('l', 71),
  _CHR('r', 59),
  _CHR('u', 35),
  _CHR('y', 35),
  _CHR('g', 24),
  _CHR('s', 12),
  _CHR('b', 12),
  _CHR('p', 12),
  _CHR('w', 12),
  PAIR('p', 't', 10),
  _CHR('i', 1090+(-1)),
  _CHR('o', 346),
  _CHR('u', 186),
  _CHR('e', 106),
  _CHR('{', 106),
  _CHR('a', 106),
  _CHR('y', 27),
  _CHR('r', 27),
  _CHR('w', 27),
  _CHR('l', 27),
  PAIR('r', 't', 17),
  _CHR('i', 544),
  _CHR('{', 301),
  _CHR('h', 258),
  _CHR('e', 243),
  _CHR('a', 200),
  _CHR('u', 115),
  _CHR('l', 100),
  _CHR('o', 72),
  _CHR('s', 43),
  _CHR('y', 43),
  _CHR('z', 29),
  _CHR('f', 29),
  _CHR('b', 14),
  _CHR('w', 14),
  _CHR('c', 14),
  _CHR('r', 14),
  _CHR('n', 14),
  PAIR('s', 't', 18),
  _CHR('{', 405+(1)),
  _CHR('i', 374),
  _CHR('a', 296),
  _CHR('e', 292),
  _CHR('r', 292),
  _CHR('o', 160),
  _CHR('u', 61),
  _CHR('y', 48),
  _CHR('h', 27),
  _CHR('w', 24),
  _CHR('l', 20),
  _CHR('m', 14),
  _CHR('n', 10),
  _CHR('s', 7),
  _CHR('b', 7),
  _CHR('p', 3),
  _CHR('f', 3),
  _CHR('d', 3),
  PAIR('t', 't', 8),
  _CHR('e', 1011+(-1)),
  _CHR('i', 247),
  _CHR('l', 247),
  _CHR('a', 197),
  _CHR('y', 173),
  _CHR('r', 99),
  _CHR('o', 49),
  _CHR('{', 25),
  PAIR('u', 't', 17),
  _CHR('e', 448+(-2)),
  _CHR('i', 397),
  _CHR('{', 333),
  _CHR('a', 154),
  _CHR('t', 154),
  _CHR('h', 115),
  _CHR('r', 102),
  _CHR('o', 102),
  _CHR('s', 51),
  _CHR('l', 38),
  _CHR('u', 38),
  _CHR('d', 26),
  _CHR('z', 26),
  _CHR('w', 26),
  _CHR('f', 13),
  _CHR('p', 13),
  _CHR('n', 13),
  PAIR('w', 't', 4),
  _CHR('h', 512+(-1)),
  _CHR('i', 512),
  _CHR('o', 512),
  _CHR('e', 512),
  PAIR('x', 't', 6),
  _CHR('r', 585+(1)),
  _CHR('e', 585),
  _CHR('u', 292),
  _CHR('{', 292),
  _CHR('o', 195),
  _CHR('i', 97),
  PAIR('y', 't', 4),
  _CHR('h', 787+(1)),
  _CHR('i', 630),
  _CHR('e', 472),
  _CHR('o', 157),
  PAIR('{', 't', 9),
  _CHR('r', 504+(1)),
  _CHR('h', 300),
  _CHR('a', 288),
  _CHR('o', 282),
  _CHR('e', 282),
  _CHR('u', 168),
  _CHR('i', 126),
  _CHR('w', 60),
  _CHR('y', 36),
  PAIR('a', 'u', 13),
  _CHR('t', 657),
  _CHR('g', 354),
  _CHR('r', 177),
  _CHR('c', 177),
  _CHR('l', 152),
  _CHR('s', 152),
  _CHR('n', 152),
  _CHR('d', 101),
  _CHR('v', 25),
  _CHR('e', 25),
  _CHR('p', 25),
  _CHR('b', 25),
  _CHR('m', 25),
  PAIR('b', 'u', 13),
  _CHR('s', 452),
  _CHR('r', 421),
  _CHR('t', 241),
  _CHR('c', 181),
  _CHR('f', 151),
  _CHR('l', 151),
  _CHR('n', 120),
  _CHR('m', 90),
  _CHR('y', 90),
  _CHR('b', 60),
  _CHR('k', 30),
  _CHR('d', 30),
  _CHR('i', 30),
  PAIR('c', 'u', 11),
  _CHR('l', 782+(-1)),
  _CHR('r', 391),
  _CHR('s', 261),
  _CHR('m', 223),
  _CHR('t', 130),
  _CHR('p', 74),
  _CHR('b', 74),
  _CHR('n', 56),
  _CHR('o', 19),
  _CHR('d', 19),
  _CHR('f', 19),
  PAIR('d', 'u', 15),
  _CHR('c', 657+(-2)),
  _CHR('s', 232),
  _CHR('l', 232),
  _CHR('n', 154),
  _CHR('r', 154),
  _CHR('a', 154),
  _CHR('e', 116),
  _CHR('p', 77),
  _CHR('{', 39),
  _CHR('k', 39),
  _CHR('f', 39),
  _CHR('m', 39),
  _CHR('d', 39),
  _CHR('g', 39),
  _CHR('o', 39),
  PAIR('e', 'u', 12),
  _CHR('r', 682+(1)),
  _CHR('t', 384),
  _CHR('k', 171),
  _CHR('c', 128),
  _CHR('d', 128),
  _CHR('g', 85),
  _CHR('p', 85),
  _CHR('{', 85),
  _CHR('m', 85),
  _CHR('n', 85),
  _CHR('v', 85),
  _CHR('s', 43),
  PAIR('f', 'u', 10),
  _CHR('l', 1228+(1)),
  _CHR('r', 289),
  _CHR('s', 193),
  _CHR('n', 144),
  _CHR('t', 48),
  _CHR('m', 48),
  _CHR('z', 24),
  _CHR('c', 24),
  _CHR('e', 24),
  _CHR('d', 24),
  PAIR('g', 'u', 11),
  _CHR('e', 416+(-1)),
  _CHR('i', 384),
  _CHR('n', 320),
  _CHR('a', 256),
  _CHR('l', 224),
  _CHR('s', 96),
  _CHR('r', 96),
  _CHR('m', 96),
  _CHR('t', 96),
  _CHR('y', 32),
  _CHR('o', 32),
  PAIR('h', 'u', 10),
  _CHR('m', 653+(-1)),
  _CHR('n', 348),
  _CHR('r', 218),
  _CHR('t', 218),
  _CHR('c', 174),
  _CHR('f', 131),
  _CHR('s', 131),
  _CHR('d', 87),
  _CHR('g', 44),
  _CHR('l', 44),
  PAIR('i', 'u', 2),
  _CHR('m', 1927),
  _CHR('r', 120),
  PAIR('j', 'u', 12),
  _CHR('n', 512),
  _CHR('m', 284),
  _CHR('d', 284),
  _CHR('s', 227),
  _CHR('r', 227),
  _CHR('t', 114),
  _CHR('v', 114),
  _CHR('i', 57),
  _CHR('a', 57),
  _CHR('k', 57),
  _CHR('g', 57),
  _CHR('b', 57),
  PAIR('k', 'u', 3),
  _CHR('p', 682+(1)),
  _CHR('l', 682),
  _CHR('d', 682),
  PAIR('l', 'u', 17),
  _CHR('s', 367+(5)),
  _CHR('t', 280),
  _CHR('e', 192),
  _CHR('m', 192),
  _CHR('n', 175),
  _CHR('g', 157),
  _CHR('r', 122),
  _CHR('b', 105),
  _CHR('x', 105),
  _CHR('o', 87),
  _CHR('c', 87),
  _CHR('d', 52),
  _CHR('l', 35),
  _CHR('a', 35),
  _CHR('p', 17),
  _CHR('i', 17),
  _CHR('k', 17),
  PAIR('m', 'u', 11),
  _CHR('l', 611+(-1)),
  _CHR('s', 399),
  _CHR('t', 346),
  _CHR('n', 266),
  _CHR('r', 80),
  _CHR('d', 80),
  _CHR('c', 80),
  _CHR('g', 53),
  _CHR('u', 53),
  _CHR('j', 53),
  _CHR('f', 27),
  PAIR('n', 'u', 11),
  _CHR('m', 485),
  _CHR('r', 269),
  _CHR('t', 269),
  _CHR('c', 215),
  _CHR('a', 215),
  _CHR('s', 162),
  _CHR('d', 162),
  _CHR('e', 108),
  _CHR('n', 54),
  _CHR('b', 54),
  _CHR('g', 54),
  PAIR('o', 'u', 13),
  _CHR('s', 983),
  _CHR('n', 325),
  _CHR('t', 236),
  _CHR('r', 229),
  _CHR('g', 81),
  _CHR('p', 59),
  _CHR('c', 37),
  _CHR('b', 30),
  _CHR('f', 15),
  _CHR('d', 15),
  _CHR('{', 15),
  _CHR('l', 15),
  _CHR('e', 7),
  PAIR('p', 'u', 10),
  _CHR('r', 529+(1)),
  _CHR('n', 388),
  _CHR('l', 388),
  _CHR('t', 282),
  _CHR('s', 141),
  _CHR('b', 106),
  _CHR('p', 71),
  _CHR('d', 71),
  _CHR('z', 35),
  _CHR('g', 35),
  PAIR('q', 'u', 4),
  _CHR('e', 811),
  _CHR('a', 608),
  _CHR('i', 567),
  _CHR('o', 61),
  PAIR('r', 'u', 15),
  _CHR('s', 457+(2)),
  _CHR('n', 347),
  _CHR('c', 256),
  _CHR('m', 164),
  _CHR('p', 164),
  _CHR('d', 110),
  _CHR('e', 91),
  _CHR('l', 91),
  _CHR('t', 91),
  _CHR('i', 73),
  _CHR('f', 55),
  _CHR('g', 55),
  _CHR('b', 55),
  _CHR('r', 18),
  _CHR('a', 18),
  PAIR('s', 'u', 17),
  _CHR('r', 392+(-3)),
  _CHR('b', 377),
  _CHR('p', 305),
  _CHR('m', 174),
  _CHR('l', 131),
  _CHR('n', 116),
  _CHR('c', 102),
  _CHR('i', 102),
  _CHR('s', 102),
  _CHR('a', 73),
  _CHR('f', 58),
  _CHR('g', 29),
  _CHR('e', 29),
  _CHR('o', 15),
  _CHR('{', 15),
  _CHR('t', 15),
  _CHR('d', 15),
  PAIR('t', 'u', 15),
  _CHR('r', 833),
  _CHR('a', 240),
  _CHR('t', 198),
  _CHR('s', 127),
  _CHR('n', 127),
  _CHR('m', 127),
  _CHR('d', 85),
  _CHR('l', 71),
  _CHR('b', 71),
  _CHR('g', 42),
  _CHR('o', 42),
  _CHR('p', 42),
  _CHR('e', 14),
  _CHR('c', 14),
  _CHR('f', 14),
  PAIR('u', 'u', 2),
  _CHR('{', 1024+(-1)),
  _CHR('m', 1024),
  TRIPLE('v', 'u', 'l'),
  TRIPLE('w', 'u', 'r'),
  PAIR('x', 'u', 3),
  _CHR('a', 1024),
  _CHR('r', 682),
  _CHR('l', 341),
  TRIPLE('z', 'u', 's'),
  PAIR('{', 'u', 10),
  _CHR('n', 1701+(1)),
  _CHR('p', 160),
  _CHR('r', 44),
  _CHR('s', 35),
  _CHR('t', 35),
  _CHR('l', 35),
  _CHR('g', 9),
  _CHR('b', 9),
  _CHR('v', 9),
  _CHR('j', 9),
  PAIR('a', 'v', 5),
  _CHR('e', 825),
  _CHR('i', 580),
  _CHR('a', 336),
  _CHR('o', 275),
  _CHR('y', 31),
  PAIR('b', 'v', 2),
  _CHR('e', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('d', 'v', 4),
  _CHR('e', 963),
  _CHR('i', 482),
  _CHR('a', 482),
  _CHR('o', 120),
  PAIR('e', 'v', 5),
  _CHR('e', 1088+(1)),
  _CHR('i', 466),
  _CHR('a', 259),
  _CHR('o', 207),
  _CHR('u', 26),
  PAIR('i', 'v', 5),
  _CHR('e', 1422),
  _CHR('i', 366),
  _CHR('a', 194),
  _CHR('o', 43),
  _CHR('u', 22),
  PAIR('l', 'v', 2),
  _CHR('e', 1755),
  _CHR('a', 292),
  PAIR('m', 'v', 2),
  _CHR('e', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('n', 'v', 6),
  _CHR('e', 1050+(1)),
  _CHR('i', 472),
  _CHR('o', 210),
  _CHR('a', 210),
  _CHR('y', 52),
  _CHR('u', 52),
  PAIR('o', 'v', 4),
  _CHR('e', 1693),
  _CHR('i', 177),
  _CHR('a', 126),
  _CHR('o', 51),
  PAIR('r', 'v', 4),
  _CHR('e', 768+(-1)),
  _CHR('i', 704),
  _CHR('a', 512),
  _CHR('o', 64),
  PAIR('u', 'v', 4),
  _CHR('e', 1024),
  _CHR('i', 341),
  _CHR('r', 341),
  _CHR('u', 341),
  PAIR('{', 'v', 4),
  _CHR('i', 649+(-1)),
  _CHR('o', 507),
  _CHR('e', 466),
  _CHR('a', 426),
  PAIR('a', 'w', 11),
  _CHR('a', 525+(2)),
  _CHR('n', 315),
  _CHR('{', 262),
  _CHR('f', 210),
  _CHR('l', 210),
  _CHR('i', 157),
  _CHR('k', 105),
  _CHR('e', 105),
  _CHR('b', 52),
  _CHR('r', 52),
  _CHR('m', 52),
  TRIPLE('b', 'w', 'e'),
  PAIR('d', 'w', 5),
  _CHR('e', 682+(1)),
  _CHR('i', 546),
  _CHR('o', 409),
  _CHR('a', 273),
  _CHR('r', 136),
  PAIR('e', 'w', 13),
  _CHR('{', 475+(-3)),
  _CHR('a', 402),
  _CHR('i', 256),
  _CHR('o', 256),
  _CHR('e', 183),
  _CHR('s', 146),
  _CHR('d', 110),
  _CHR('h', 37),
  _CHR('t', 37),
  _CHR('r', 37),
  _CHR('p', 37),
  _CHR('c', 37),
  _CHR('b', 37),
  TRIPLE('g', 'w', 'r'),
  PAIR('h', 'w', 3),
  _CHR('a', 1365),
  _CHR('i', 341),
  _CHR('o', 341),
  PAIR('k', 'w', 2),
  _CHR('o', 1365),
  _CHR('a', 682),
  TRIPLE('l', 'w', 'o'),
  PAIR('m', 'w', 2),
  _CHR('a', 1024+(-1)),
  _CHR('o', 1024),
  PAIR('n', 'w', 3),
  _CHR('a', 1228),
  _CHR('i', 614),
  _CHR('o', 205),
  PAIR('o', 'w', 16),
  _CHR('n', 431+(2)),
  _CHR('{', 431),
  _CHR('e', 369),
  _CHR('l', 123),
  _CHR('i', 123),
  _CHR('s', 123),
  _CHR('a', 92),
  _CHR('b', 62),
  _CHR('d', 62),
  _CHR('y', 46),
  _CHR('m', 46),
  _CHR('t', 46),
  _CHR('p', 46),
  _CHR('c', 15),
  _CHR('w', 15),
  _CHR('r', 15),
  PAIR('p', 'w', 4),
  _CHR('e', 768+(-1)),
  _CHR('a', 768),
  _CHR('r', 256),
  _CHR('o', 256),
  PAIR('r', 'w', 5),
  _CHR('a', 945+(1)),
  _CHR('o', 630),
  _CHR('i', 157),
  _CHR('h', 157),
  _CHR('e', 157),
  PAIR('s', 'w', 4),
  _CHR('i', 665),
  _CHR('a', 665),
  _CHR('e', 563),
  _CHR('o', 154),
  PAIR('t', 'w', 7),
  _CHR('i', 662+(1)),
  _CHR('a', 542),
  _CHR('o', 361),
  _CHR('e', 241),
  _CHR('h', 120),
  _CHR('u', 60),
  _CHR('r', 60),
  TRIPLE('w', 'w', 'o'),
  TRIPLE('x', 'w', 'o'),
  PAIR('y', 'w', 3),
  _CHR('a', 1024+(-1)),
  _CHR('o', 512),
  _CHR('e', 512),
  PAIR('{', 'w', 6),
  _CHR('a', 595),
  _CHR('i', 385),
  _CHR('o', 323),
  _CHR('h', 310),
  _CHR('e', 285),
  _CHR('r', 149),
  PAIR('a', 'x', 5),
  _CHR('i', 787+(2)),
  _CHR('{', 787),
  _CHR('m', 157),
  _CHR('o', 157),
  _CHR('e', 157),
  PAIR('e', 'x', 13),
  _CHR('p', 550+(1)),
  _CHR('c', 396),
  _CHR('t', 396),
  _CHR('i', 154),
  _CHR('{', 110),
  _CHR('h', 110),
  _CHR('u', 88),
  _CHR('a', 66),
  _CHR('o', 66),
  _CHR('e', 44),
  _CHR('l', 22),
  _CHR('f', 22),
  _CHR('y', 22),
  PAIR('i', 'x', 4),
  _CHR('{', 819),
  _CHR('t', 614),
  _CHR('e', 409),
  _CHR('a', 205),
  PAIR('n', 'x', 2),
  _CHR('{', 1365),
  _CHR('i', 682),
  PAIR('o', 'x', 6),
  _CHR('i', 834+(-1)),
  _CHR('{', 834),
  _CHR('y', 152),
  _CHR('e', 76),
  _CHR('f', 76),
  _CHR('w', 76),
  PAIR('u', 'x', 2),
  _CHR('{', 1365),
  _CHR('u', 682),
  PAIR('a', 'y', 14),
  _CHR('{', 1199+(4)),
  _CHR('i', 175),
  _CHR('a', 146),
  _CHR('e', 146),
  _CHR('o', 58),
  _CHR('g', 58),
  _CHR('l', 58),
  _CHR('t', 29),
  _CHR('n', 29),
  _CHR('w', 29),
  _CHR('f', 29),
  _CHR('d', 29),
  _CHR('m', 29),
  _CHR('b', 29),
  PAIR('b', 'y', 4),
  _CHR('{', 1489),
  _CHR('o', 186),
  _CHR('l', 186),
  _CHR('t', 186),
  PAIR('c', 'y', 6),
  _CHR('{', 1505),
  _CHR('c', 181),
  _CHR('t', 181),
  _CHR('b', 60),
  _CHR('a', 60),
  _CHR('m', 60),
  PAIR('d', 'y', 7),
  _CHR('{', 1057),
  _CHR('n', 528),
  _CHR('s', 198),
  _CHR('c', 66),
  _CHR('a', 66),
  _CHR('b', 66),
  _CHR('m', 66),
  PAIR('e', 'y', 7),
  _CHR('{', 1310+(-1)),
  _CHR('e', 328),
  _CHR('m', 82),
  _CHR('c', 82),
  _CHR('s', 82),
  _CHR('w', 82),
  _CHR('h', 82),
  PAIR('f', 'y', 2),
  _CHR('{', 1732),
  _CHR('i', 315),
  PAIR('g', 'y', 3),
  _CHR('{', 1651),
  _CHR('n', 264),
  _CHR('m', 132),
  PAIR('h', 'y', 10),
  _CHR('{', 533),
  _CHR('p', 477),
  _CHR('s', 365),
  _CHR('d', 308),
  _CHR('l', 140),
  _CHR('r', 56),
  _CHR('g', 56),
  _CHR('t', 56),
  _CHR('m', 28),
  _CHR('o', 28),
  TRIPLE('i', 'y', 'e'),
  PAIR('k', 'y', 2),
  _CHR('{', 1927),
  _CHR('a', 120),
  PAIR('l', 'y', 14),
  _CHR('{', 1853+(2)),
  _CHR('s', 46),
  _CHR('c', 26),
  _CHR('m', 20),
  _CHR('a', 15),
  _CHR('t', 15),
  _CHR('g', 15),
  _CHR('n', 10),
  _CHR('z', 10),
  _CHR('p', 10),
  _CHR('e', 10),
  _CHR('i', 5),
  _CHR('o', 5),
  _CHR('b', 5),
  PAIR('m', 'y', 7),
  _CHR('{', 1157),
  _CHR('c', 267),
  _CHR('s', 267),
  _CHR('t', 89),
  _CHR('r', 89),
  _CHR('o', 89),
  _CHR('a', 89),
  PAIR('n', 'y', 6),
  _CHR('{', 1489),
  _CHR('m', 186),
  _CHR('p', 93),
  _CHR('a', 93),
  _CHR('s', 93),
  _CHR('t', 93),
  PAIR('o', 'y', 6),
  _CHR('{', 834+(-1)),
  _CHR('a', 455),
  _CHR('e', 455),
  _CHR('m', 152),
  _CHR('s', 76),
  _CHR('r', 76),
  PAIR('p', 'y', 5),
  _CHR('{', 1424),
  _CHR('r', 267),
  _CHR('b', 178),
  _CHR('i', 89),
  _CHR('l', 89),
  PAIR('r', 'y', 12),
  _CHR('{', 1680+(1)),
  _CHR('o', 85),
  _CHR('m', 71),
  _CHR('i', 56),
  _CHR('p', 42),
  _CHR('e', 28),
  _CHR('n', 14),
  _CHR('b', 14),
  _CHR('t', 14),
  _CHR('s', 14),
  _CHR('l', 14),
  _CHR('a', 14),
  PAIR('s', 'y', 10),
  _CHR('{', 548+(-2)),
  _CHR('n', 439),
  _CHR('c', 439),
  _CHR('m', 329),
  _CHR('r', 73),
  _CHR('s', 73),
  _CHR('b', 37),
  _CHR('p', 37),
  _CHR('l', 37),
  _CHR('w', 37),
  PAIR('t', 'y', 8),
  _CHR('{', 1805+(1)),
  _CHR('l', 81),
  _CHR('p', 81),
  _CHR('c', 27),
  _CHR('e', 13),
  _CHR('m', 13),
  _CHR('r', 13),
  _CHR('i', 13),
  PAIR('u', 'y', 3),
  _CHR('{', 1024+(-1)),
  _CHR('e', 512),
  _CHR('b', 512),
  PAIR('v', 'y', 2),
  _CHR('{', 1024+(-1)),
  _CHR('w', 1024),
  TRIPLE('w', 'y', '{'),
  PAIR('x', 'y', 3),
  _CHR('{', 682+(1)),
  _CHR('g', 682),
  _CHR('l', 682),
  PAIR('z', 'y', 3),
  _CHR('{', 1732+(1)),
  _CHR('d', 157),
  _CHR('g', 157),
  PAIR('{', 'y', 4),
  _CHR('a', 796),
  _CHR('e', 682),
  _CHR('o', 455),
  _CHR('i', 114),
  PAIR('a', 'z', 6),
  _CHR('z', 512+(1)),
  _CHR('e', 426),
  _CHR('i', 426),
  _CHR('y', 341),
  _CHR('a', 256),
  _CHR('o', 85),
  PAIR('e', 'z', 4),
  _CHR('e', 1489),
  _CHR('o', 186),
  _CHR('i', 186),
  _CHR('u', 186),
  PAIR('i', 'z', 6),
  _CHR('e', 1095),
  _CHR('a', 503),
  _CHR('i', 215),
  _CHR('z', 126),
  _CHR('{', 54),
  _CHR('o', 54),
  PAIR('n', 'z', 3),
  _CHR('a', 682+(1)),
  _CHR('i', 682),
  _CHR('o', 682),
  PAIR('o', 'z', 5),
  _CHR('e', 1228+(-1)),
  _CHR('y', 205),
  _CHR('i', 205),
  _CHR('o', 205),
  _CHR('z', 205),
  PAIR('r', 'z', 2),
  _CHR('e', 1024+(-1)),
  _CHR('i', 1024),
  PAIR('t', 'z', 5),
  _CHR('{', 930+(1)),
  _CHR('y', 558),
  _CHR('p', 186),
  _CHR('l', 186),
  _CHR('e', 186),
  TRIPLE('u', 'z', 'z'),
  TRIPLE('y', 'z', 'e'),
  PAIR('z', 'z', 7),
  _CHR('l', 512+(-1)),
  _CHR('y', 384),
  _CHR('i', 384),
  _CHR('{', 256),
  _CHR('a', 256),
  _CHR('e', 128),
  _CHR('m', 128),
  PAIR('{', 'z', 4),
  _CHR('o', 768+(-1)),
  _CHR('y', 512),
  _CHR('e', 512),
  _CHR('i', 256),
  PAIR('{', '{', 25),
  _CHR('s', 238+(1)),
  _CHR('c', 194),
  _CHR('p', 170),
  _CHR('d', 128),
  _CHR('m', 118),
  _CHR('b', 116),
  _CHR('a', 116),
  _CHR('r', 113),
  _CHR('t', 103),
  _CHR('f', 87),
  _CHR('i', 86),
  _CHR('e', 83),
  _CHR('h', 77),
  _CHR('g', 71),
  _CHR('u', 70),
  _CHR('l', 60),
  _CHR('w', 50),
  _CHR('o', 48),
  _CHR('n', 40),
  _CHR('v', 31),
  _CHR('j', 19),
  _CHR('k', 14),
  _CHR('q', 7),
  _CHR('y', 5),
  _CHR('z', 2),
  END 
};

char* CMarkovWord::Word(char* Buffer, int BufferSize, int MinLength, int MaxLength)
{
  int Length;
  do 
  {
    int Idx = 0;
    Buffer[0] = Buffer[1] = '{';
    do 
    {
      Buffer[Idx + 2] = NextChar(Buffer[Idx], Buffer[Idx + 1]);
      Idx++;
    } while (Buffer[Idx + 1] != '{' && Idx < (BufferSize - 1));
    Buffer[Idx + 1] = 0;

    Length = strlen(Buffer + 2);
  } while (Length < MinLength || Length > MaxLength);
  return Buffer + 2;
}

char CMarkovWord::NextChar(char First, char Second)
{
/*
table is a sequence of WORDs
  PAIR
  _CHR
  _CHR
   ...
  TRIPLE
  PAIR
  _CHR
  _CHR
   ...
  END

  PAIR is 0lll llss sssf ffff (<-lsb)
    fffff 5 bits of first char index
    sssss 5 bits of second char index
    0lllll 5 bits of length
  or if length would be 1:
  TRIPLE is 1ttt ttss sssf ffff (<-lsb)
    fffff 5 bits of first char index
    sssss 5 bits of second char index
    ttttt 5 bits of third char index (p = 0x7FF)

  _CHR is pppp pppp pppt tttt
    ttttt 5 bits of third char index
    ppppppppppp is 11 bits of "probability"/normalized count
  END is 0x0000
*/

  word Mask = 0x03FF;
  word Pair = PAIR(First, Second, 0);
  int ItemIdx = 0;
  word Item = pgm_read_word(kMarkovTable + ItemIdx);
  while (Item)
  {
    if ((Item & Mask) == Pair)
    {
      if (Item & 0x8000)
      {
        // triple
        return 'a' + ((Item >> 10) & 0x1F);
      }
      else
      {
        int Len = Item >> 10;
        word Rand = random(2048);
        word Sum = 0;
        for (int Ch = 0; Ch < Len; Ch++)
        {
          ItemIdx++;
          Item = pgm_read_word(kMarkovTable + ItemIdx);
          Sum += Item >> 5;
          if (Sum >= Rand)
          {
            return 'a' + (Item & 0x1F);
          }
        }
        // did not find the char?
        return '{';
      }
    }
    else
    {
      if (Item & 0x8000)
      {
        // triple
        ItemIdx++;
        Item = pgm_read_word(kMarkovTable + ItemIdx);
      }
      else
      {
        int Offs = (Item >> 10) + 1;
        ItemIdx += Offs;
        Item = pgm_read_word(kMarkovTable + ItemIdx);
      }
    }
  }
  // could not find the pair
  return '{';
}

